<%-- $Id: edit_annotationtype.jsp 5967 2012-02-16 08:33:45Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationType annotationType = null;
	ItemQuery<AnnotationTypeCategory> categoryQuery = null;
	ItemQuery<Unit> unitQuery = null;
	Type valueType = null;
	boolean readCurrentQuantity = true;
	int currentQuantityId = 0;
	boolean readCurrentUnit = true;
	int currentUnitId = 0;

	if (itemId == 0)
	{
		title = "Create annotation type";
		valueType = Type.valueOf(request.getParameter("value_type"));
		if (valueType.isNumerical()) unitQuery = Unit.getQuery();	
		cc.removeObject("item");
	}
	else
	{
		annotationType = AnnotationType.getById(dc, itemId);
		annotationType.checkPermission(Permission.WRITE);
		valueType = annotationType.getValueType();
		cc.setObject("item", annotationType);
		title = "Edit annotation type -- " + HTML.encodeTags(annotationType.getName());
		categoryQuery = annotationType.getCategories();
		categoryQuery.include(Include.ALL);
		categoryQuery.order(Orders.asc(Hql.property("name")));
		try
		{
			if (annotationType.getValueType().isNumerical())
			{
				Quantity quantity = annotationType.getQuantity();
				if (quantity != null) 
				{
					currentQuantityId = quantity.getId();
					unitQuery = quantity.getUnits();
				}
				else
				{
					unitQuery = Unit.getQuery();
				}
				Unit unit = annotationType.getDefaultUnit();
				if (unit != null) currentUnitId = unit.getId();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentQuantity = false;
			readCurrentUnit = false;
		}
	}

	if (unitQuery != null)
	{
		unitQuery.include(Include.ALL);
		unitQuery.order(Orders.asc(Hql.property("quantity.name")));
		unitQuery.order(Orders.asc(Hql.property("referenceFactor")));
		unitQuery.order(Orders.asc(Hql.property("name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String jsDateTimeFormat = HTML.javaScriptEncode(dateTimeFormat);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), annotationType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js,units.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Annotation type" tab
		function validateAnnotationType()
		{
			var frm = document.forms['annotationType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		
		function validateOptions()
		{
			return true;
		}
		
		function validateItemTypes()
		{
			return true;
		}

		function validateUnits()
		{
			return true;
		}
		
		function validateCategories()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['annotationType'];
			if (TabControl.validateActiveTab('settings'))
			{
				var enabled = frm.enabled;
				for (var i = 0; i < enabled.length; i++) // >
				{
					enabled.options[i].selected = true;
				}
				frm.addCategories.value = Link.getActionIds(1, 'C').join(',');
				frm.removeCategories.value = Link.getActionIds(-1, 'C').join(',');
				if (frm.addUsableUnits && frm.removeUsableUnits)
				{
					frm.addUsableUnits.value = Link.getActionIds(1, 'U').join(',');
					frm.removeUsableUnits.value = Link.getActionIds(-1, 'U').join(',');
				}
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (annotationType == null)
			{
				%>
				var frm = document.forms['annotationType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initItemTypes();
			initCategories();
			initUnits();
			interfaceOnClick();
		}

		function initUnits()
		{
			var frm = document.forms['annotationType'];
			var quantityList = frm.quantity_id;
			var unitList = frm.unit_id;
			var quantity;
			<%
			if (unitQuery != null)
			{
				List<Unit> units = unitQuery.list(dc);
				Quantity prevQuantity = null;
				for (Unit unit : units)
				{
					Quantity quantity = unit.getQuantity();
					if (!quantity.equals(prevQuantity))
					{
						%>
						quantity = new Quantity(<%=quantity.getId()%>, '<%=HTML.javaScriptEncode(quantity.getName())%>');
						<%
						prevQuantity = quantity;
					}
					%>
					quantity.addUnit(<%=unit.getId()%>, '<%=HTML.javaScriptEncode(unit.getName())%>', '<%=HTML.javaScriptEncode(unit.getDisplaySymbol())%>');
					<%
				}
			}
			%>
			if (quantityList && unitList)
			{
				Quantities.populateLists(quantityList, unitList, <%=currentQuantityId%>, <%=currentUnitId%>);
				Quantities.updateUnitsList(quantityList[quantityList.selectedIndex].quantity, frm.allUnits);
				var usableUnits = new Array();
				<%
				if (annotationType != null)
				{
					ItemQuery<Unit> usableQuery = annotationType.getUsableUnits();
					usableQuery.include(Include.ALL);
					usableQuery.order(Orders.asc(Hql.property("referenceFactor")));
					usableQuery.order(Orders.asc(Hql.property("name")));
					
					ItemResultList<Unit> usableUnits = usableQuery.list(dc);
					for (Unit u : usableUnits)
					{
						%>
						usableUnits['ID<%=u.getId()%>'] = true;
						<%
					}
				}
				%>
				addToUsableUnits(usableUnits);
			}
		}
		
		function quantityOnChange()
		{
			var frm = document.forms['annotationType'];
			var quantityList = frm.quantity_id;
			var unitList = frm.unit_id;
			var quantity = quantityList[quantityList.selectedIndex].quantity;
			Quantities.updateUnitsList(quantity, unitList, <%=currentUnitId%>);
			Quantities.updateUnitsList(quantity, frm.allUnits);
		}

		function addToUsableUnits(usableUnits)
		{
			var frm = document.forms['annotationType'];
			for (var i = 0; i < frm.allUnits.length; i++)
			{
				var option = frm.allUnits[i];
				if (option.selected || (usableUnits && usableUnits['ID'+option.value]))
				{
					addUsableUnit(option.value, option.text, usableUnits);
					frm.allUnits[i--] = null;
				}
			}
		}

		function addUsableUnit(unitId, name, asNew)
		{
			var item = Link.getItem('U', unitId);
			if (!item) item = new Item('U', unitId, name);
			if (asNew)
			{
				Link.addNewItem(document.forms['annotationType'].usableUnits, item);
			}
			else
			{
				Link.addItem(document.forms['annotationType'].usableUnits, item);
			}
		}
		function removeFromUsableUnits()
		{
			var frm = document.forms['annotationType'];
			Link.removeSelected(frm.usableUnits, frm.allUnits);
		}
		
		function initItemTypes()
		{
			var frm = document.forms['annotationType'];
			var enabled = frm.enabled;
			var disabled = frm.disabled;
			<%
			Set<Item> items = Metadata.getAnnotatableItems();
			int itemCode = Values.getInt(cc.getPropertyValue("@itemTypes"), -1);
			for (Item item : items)
			{
				%>
				var option = new Option('<%=item.toString()%>', '<%=item.name()%>');
				Forms.addListOption(<%=(annotationType == null && itemCode == item.getValue()) || 
					(annotationType != null && annotationType.isEnabledForItem(item)) ? "enabled" : "disabled"%>, -1, option);
				<%
			}
			%>
		}
		
		function initCategories()
		{
			var categories = document.forms['annotationType'].categories;
			<%
			if (categoryQuery != null)
			{
				ItemResultList<AnnotationTypeCategory> categories = categoryQuery.list(dc);
				for (AnnotationTypeCategory category : categories)
				{
					%>
					Link.addNewItem(categories, new Item('C', <%=category.getId()%>, '<%=HTML.javaScriptEncode(category.getName())%>'));
					<%
				}
			}
			%>
		}
		function addCategoriesOnClick()
		{
			var categories = Link.getListIds(document.forms['annotationType'].categories, 'C');
			var url = '../annotationtypecategories/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addCategoryCallback';
			url += '&exclude='+categories.join(',');
			Main.openPopup(url, 'AddCategories', 1050, 700);
		}
		
		function addCategoryCallback(categoryId, name)
		{
			var item = Link.getItem('C', categoryId);
			if (!item) item = new Item('C', categoryId, name);
			Link.addItem(document.forms['annotationType'].categories, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['annotationType'].categories);
		}
		
		// Moves all selected items in list1 to list2
		function moveBetween(list1, list2)
		{
			var moved = 0;
			for(i=0; i < list1.options.length; i++) // >
			{
				if (list1.options[i].selected)
				{
					moved++;
					list2.options[list2.options.length] = new Option(list1.options[i].text, list1.options[i].value, false, true);
					list1.options[i] = null;
					i--;
				}
			}
		}
		
		function interfaceOnClick()
		{
			var frm = document.forms['annotationType'];
			if (frm['interface'])
			{
				var isEnum = Forms.getCheckedRadio(frm['interface']).value != 'box';
				if (frm.minValue) frm.minValue.disabled = isEnum;
				if (frm.maxValue) frm.maxValue.disabled = isEnum;
				if (frm.width) frm.width.disabled = isEnum;
				if (frm.maxLength) frm.maxLength.disabled = isEnum;
				if (frm.values) frm.values.disabled = !isEnum;
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="value_type" value="<%=valueType.name()%>">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=annotationType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Annotation type" validate="validateAnnotationType()" helpid="annotationtype.edit">
			<table class="fullform input100">
			<tr>
				<th>Value type</th>
				<td><%=valueType%></td>
				<td></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(annotationType == null ? 
					Values.getString(cc.getPropertyValue("name"), "New "+valueType+" annotation type") : annotationType.getName())%>" 
					maxlength="<%=AnnotationType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(annotationType == null ? 
					Values.getString(cc.getPropertyValue("externalId"), "") : annotationType.getExternalId())%>" 
					maxlength="<%=AnnotationType.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Multiplicity</td>
				<td><input <%=clazz%> type="text" name="multiplicity" 
					value="<%=annotationType == null ? Values.getString(cc.getPropertyValue("multiplicity"), "1") : 
					Integer.toString(annotationType.getMultiplicity())%>" style="width: 15em;"
					maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					0 or empty = unlimited
				</td>
				<td></td>
			</tr>
			<tr class="<%=valueType == Type.TEXT ? "big" : ""%>">
				<th>Default value</th>
				<td>
					<%
					String defaultValue = annotationType == null ? cc.getPropertyValue("defaultValue") : annotationType.getDefaultValue();
					boolean hasZoom = false;
					if (valueType == Type.INT || valueType == Type.LONG)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						<%
					}
					else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						<%
					}
					else if (valueType == Type.BOOLEAN)
					{
						boolean booleanDefaultValue = Values.getBoolean(defaultValue);
						%>
						<input type="radio" name="defaultValue" id="defaultTrue" value="true" 
							<%=booleanDefaultValue ? "checked" : ""%>
						><label for="defaultTrue">true</label>
						<input type="radio" name="defaultValue" id="defaultFalse" value="false" 
							<%=booleanDefaultValue ? "" : "checked"%>
						><label for="defaultFalse">false</label>
						<%
					}
					else if (valueType == Type.DATE)
					{
						%>
						<table>
						<tr>
						<td>
							<input <%=clazz%> type="text" name="defaultValue" 
								value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
								maxlength="20 "title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
							<base:button 
								onclick="<%="Dates.selectDate('Default value', 'annotationType', 'defaultValue', null, '"+jsDateFormat+"')"%>" 
								image="calendar.png"
								title="Calendar&hellip;" 
								tooltip="Select a date from a calendar" 
							/>
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.TIMESTAMP)
					{
						%>
						<table>
						<tr>
						<td>
							<input <%=clazz%> type="text" name="defaultValue" 
								value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
								maxlength="30 "title="Enter date in format: <%=htmlDateTimeFormat%>">
						</td>
						<td>
							<base:button 
								onclick="<%="Dates.selectDateTime('Default value', 'annotationType', 'defaultValue', null, '"+jsDateTimeFormat+"')"%>" 
								image="calendar.png"
								title="Calendar&hellip;" 
								tooltip="Select a date and time from a calendar" 
							/>
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.STRING)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" 
							maxlength="<%=AnnotationType.MAX_DEFAULT_VALUE_LENGTH%>">
					<%
					}
					else if (valueType == Type.TEXT)
					{
						hasZoom = true;
						%>
						<textarea <%=clazz%> rows="4" name="defaultValue" 
							><%=HTML.encodeTags(defaultValue)%></textarea>
						<%
					}
					%>
				</td>
				<td>
				<%
				if (hasZoom)
				{
					%>
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Default value', 'annotationType', 'defaultValue')"
						tooltip="Edit in larger window"
					/>
					<%
				}
				%>
				</td>
			</tr>
			<tr>
				<th><label for="required_for_miame">Required for MIAME</label></th>
				<td><input type="checkbox" name="required_for_miame" id="required_for_miame" value="1" 
					<%=(annotationType != null && annotationType.isRequiredForMiame()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("requiredForMiame"))) ? "checked" : ""%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="is_protocol_parameter">Protocol parameter</label></th>
				<td><input type="checkbox" name="is_protocol_parameter" id="is_protocol_parameter" value="1" 
					<%=(annotationType != null && annotationType.isProtocolParameter()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("protocolParameter"))) ? "checked" : ""%>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" name="description" 
						><%=HTML.encodeTags(annotationType == null ? cc.getPropertyValue("description") : annotationType.getDescription())%></textarea>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'annotationType', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="options" title="Options" validate="validateOptions()" helpid="annotationtype.edit.options">
			<%
			if (valueType == Type.INT || valueType == Type.LONG)
			{
				Long minValue = annotationType == null ? null : annotationType.getMinValueLong();
				Long maxValue = annotationType == null ? null : annotationType.getMaxValueLong();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Min value</th>
					<td>
						<input <%=clazz%> type="text" name="minValue" 
							value="<%=minValue == null ? "" : minValue.toString()%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max value</th>
					<td>
						<input <%=clazz%> type="text" name="maxValue" 
							value="<%=maxValue == null ? "" : maxValue.toString()%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" style="width: 15em;"
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" name="values" 
							onkeypress="return Numbers.integerOnly(event)"><%=HTML.encodeTags(values)%></textarea><br>
					</td>
					<td style="width: 20px;">
						<base:icon image="zoom.png" 
							onclick="Main.zoom('Values', 'annotationtype', 'values')"
							tooltip="Edit in larger window"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
			{
				Double minValue = annotationType == null ? null : annotationType.getMinValueDouble();
				Double maxValue = annotationType == null ? null : annotationType.getMaxValueDouble();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Min value</th>
					<td>
						<input <%=clazz%> type="text" name="minValue" 
							value="<%=minValue == null ? "" : minValue.toString()%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max value</th>
					<td>
						<input <%=clazz%> type="text" name="maxValue" 
							value="<%=maxValue == null ? "" : maxValue.toString()%>" style="width: 15em;"
							maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" name="values" 
							onkeypress="return Numbers.numberOnly(event)"><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:icon image="zoom.png" 
							onclick="Main.zoom('Values', 'annotationtype', 'values')"
							tooltip="Edit in larger window"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.BOOLEAN)
			{
				%>
				<div style="border: 1px solid transparent;">
				<div class="messagecontainer help">
				No options for this type.
				</div>
				</div>
				<%
			}
			else if (valueType == Type.DATE)
			{
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : 
							Values.getString((List<Date>)annotationType.getValues(), "\n", true, dateFormatter);
						%>
						<textarea <%=clazz%> rows="10" name="values" 
							><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:icon image="zoom.png" 
							onclick="Main.zoom('Values', 'annotationtype', 'values')"
							tooltip="Edit in larger window"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One date value (<%=htmlDateFormat%>) per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.TIMESTAMP)
			{
				%>
				<table class="fullform input100">
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr class="dynamic">
					<th class="subprompt"></th>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.STRING)
			{
				Integer maxLength = annotationType == null ? null : annotationType.getMaxLength();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max length</th>
					<td>
						<input <%=clazz%> type="text" name="maxLength" 
							value="<%=maxLength == null ? "" : maxLength.toString()%>" style="width: 5em;"
							maxlength="3" onkeypress="return Numbers.integerOnly(event)"> (1-255)
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" name="values" ><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:icon image="zoom.png" 
							onclick="Main.zoom('Values', 'annotationtype', 'values')"
							tooltip="Edit in larger window"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.TEXT)
			{
				%>
				<table class="fullform input100">
				<tr>
					<th>Input box width</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr>
					<th>Input box height</th>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getHeight()%>" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
				<%
			}
			%>
		</t:tab>
		
		<t:tab id="items" title="Item types" validate="validateItemTypes()" helpid="annotationtype.edit.items">
			<div style="padding: 2px;">
			<table style="width: 100%;">
			<tr>
				<td style="width: 50%;">
					<b>Enabled for</b><br>
					<select name="enabled" multiple size="14" style="width: 99%;"
						ondblclick="moveBetween(document.forms['annotationType'].enabled, document.forms['annotationType'].disabled)">
					</select>
				</td>
				<td style="width: 20px; padding: 2px;">
					<base:buttongroup vertical="true">
						<base:button
							onclick="moveBetween(document.forms['annotationType'].disabled, document.forms['annotationType'].enabled)" 
							image="move_left.png" 
							tooltip="Enable the annotation type for the selected item(s)" 
							subclass="square"
						/>
						<base:button 
							onclick="moveBetween(document.forms['annotationType'].enabled, document.forms['annotationType'].disabled)" 
							image="move_right.png" 
							subclass="square"
							tooltip="Disable the annotation type for the selected item(s)" 
					/>
					</base:buttongroup>
				</td>
				<td style="width: 50%;">
					<b>Disabled for</b><br>
					<select name="disabled" multiple size="14" style="width: 99%;"
						ondblclick="moveBetween(document.forms['annotationType'].disabled, document.forms['annotationType'].enabled)">
					</select>
				</td>
			</tr>
			</table>
			</div>
		</t:tab>
		
		<t:tab id="units" title="Units" validate="validateUnits()" 
			visible="<%=valueType.isNumerical()%>" helpid="annotationtype.edit.units">
		
			<table class="fullform input100">
			<tr>
				<th>Quantity</th>
				<td>
					<select name="quantity_id" onchange="quantityOnChange()"
						<%=!readCurrentQuantity || (annotationType != null && currentQuantityId != 0) ? 
								"disabled readonly class=\"disabled\"" : "class=\"unchangeable selectionlist\""%>>
						<option value="">- do not use units -
					</select>
				</td>
			</tr>
			<tr>
				<th>Default unit</th>
				<td>
					<select name="unit_id" 
						<%=!readCurrentQuantity ? "disabled readonly class=\"disabled\"" : "class=\"selectionlist\""%>>
					</select>
				</td>
			</tr>
			<%
			if (annotationType != null)
			{
				%>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help">
						Changing the default unit triggers a conversion of existing annotation values
						to the new unit. This may result in loss of precision due to rounding or 
						truncation.
						</div>
					</td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th></th>
				<td>
					<table style="width: 100%;">
					<tr>
						<th>Use units</th>
						<td></td>
						<th>Do not use</th>
					</tr>
					<tr>
						<td style="width: 50%;">
							<select name="usableUnits" size="10" multiple style="width: 100%;" ondblclick="removeFromUsableUnits()"
								title="If no unit is selected, all units can be used"
							>
							</select>
						</td>
						<td style="width: 20px; padding: 2px;">
							<base:buttongroup vertical="true">
								<base:button
									onclick="addToUsableUnits()"
									image="move_left.png"
									subclass="square"
									tooltip="Enable the annotation type for the selected unit(s)" 
								/>
								<base:button 
									onclick="removeFromUsableUnits()"
									image="move_right.png"
									subclass="square"
									tooltip="Disable the annotation type for the selected unit(s)" 
								/>
							</base:buttongroup>
						</td>
						<td style="width: 50%;">
							<select name="allUnits" size="10" multiple style="width: 100%;" ondblclick="addToUsableUnits()">
							</select>
							<input type="hidden" name="removeUsableUnits" value="">
							<input type="hidden" name="addUsableUnits" value="">
						</td>
					</tr>
					</table>
				</td>
			</table>
		</t:tab>

		<t:tab id="categories" title="Categories" validate="validateCategories()" 
			helpid="annotationtype.edit.categories">
			<table class="fullform input100">
			<tr class="dynamic">
				<th>Categories</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="categories" size="14" multiple>
							</select>
							<input type="hidden" name="removeCategories" value="">
							<input type="hidden" name="addCategories" value="">
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button
									subclass="leftaligned" 
									style="width: 14em;"
									onclick="addCategoriesOnClick()" 
									title="Add&nbsp;categories&hellip;" 
									tooltip="Add categories to this annotation type"
									/>
								<base:button 
									subclass="leftaligned" 
									style="width: 14em;"
									onclick="removeOnClick()" 
									title="Remove" 
									tooltip="Remove the selected categories from this annotation type"
								/>
							</base:buttongroup>
						</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information<br>
			<base:icon image="unchangeable.png" />= can't be changed later
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
