<%-- $Id: view_client.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.CLIENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Client client = Client.getById(dc, itemId);
	
	final boolean writePermission = client.hasPermission(Permission.WRITE);
	final boolean deletePermission = client.hasPermission(Permission.DELETE);
	final boolean sharePermission = client.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = client.hasPermission(Permission.SET_OWNER);
	final boolean isOwner = client.isOwner();
	final boolean isRemoved = client.isRemoved();
	final boolean isUsed = isRemoved && client.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, client);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareClient', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 300);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 750, 500);
		}
		function viewHelp()
		{
			location.href = 'help/index.jsp?ID=<%=ID%>&cmd=List&client_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'help')
			{
				viewHelp();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Client applications" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(client.getName())%>"
			/></p:path>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="properties" switch="switchTab">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=client.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						image="deleted.png"
						onclick="deleteItemPermanently()"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon image="used.png" 
						onclick="showUsingItems()"
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							onclick="editItem()" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this client application" : "You do not have permission to edit this client application"%>" 
						/>
						<tbl:button 
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							onclick="deleteItem()" 
							title="Delete"
							visible="<%=!client.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this client application" : "You do not have permission to delete this client application"%>" 
						/>
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							onclick="restoreItem()" 
							title="Restore"
							visible="<%=client.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this client application" : "You do not have permission to restore this client application"%>" 
						/>
						<tbl:button 
							disabled="<%=!sharePermission%>"
							image="share.png"
							onclick="shareItem()" 
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this client application to other user, groups and projects" : "You do not have permission to share this client application"%>"
						/>
						<tbl:button 
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							onclick="setOwner()" 
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							image="import.png" 
							onclick="runPlugin('ImportItem')" 
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							image="export.png" 
							onclick="runPlugin('ExportItem')" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							image="runplugin.png" 
							onclick="runPlugin('RunPlugin')" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							onclick="<%="Main.openHelp('" + ID +"', 'client.view.properties')"%>"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(client.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(client.getEntryDate())%></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><%=HTML.encodeTags(client.getExternalId())%></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=client%>" property="owner" /></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(client)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(client.getDescription())%></td>
			</tr>
			</table>
			</div>
			
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this client application" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
		</t:tab>
			
		<t:tab id="help" title="Help texts" 
			tooltip="View and manage help texts for this client application" />
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
