<%-- $Id: list_subtypes.jsp 5983 2012-02-23 14:45:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@since 3.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ITEMSUBTYPE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
	private static final Enumeration<String, String> items = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getSubtypableItems())
		{
			items.add(Integer.toString(item.getValue()), item.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean writePermission = sc.hasPermission(Permission.WRITE, itemType);
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean deletePermission = sc.hasPermission(Permission.DELETE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("item subtype", "item subtypes");
final DbControl dc = sc.newDbControl();
ItemResultIterator<ItemSubtype> subtypes = null;
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

	ItemQuery<ItemSubtype> relatedQuery = ItemSubtype.getQuery(null);
	relatedQuery.join(Hql.innerJoin("parents", "pp"));
	relatedQuery.restrict(Restrictions.eq(Hql.alias("pp"), Hql.entityParameter("subtype", Item.ITEMSUBTYPE)));
	relatedQuery.order(Orders.asc(Hql.property("name")));
	relatedQuery.include(cc.getInclude());
	
	final ItemQuery<DataFileType> fileTypesQuery = DataFileType.getQuery();
	fileTypesQuery.include(cc.getInclude());
	fileTypesQuery.join(Hql.innerJoin("itemSubtypes", "ist"));
	fileTypesQuery.restrict(Restrictions.eq(Hql.alias("ist"), Expressions.parameter("subtype")));
	fileTypesQuery.order(Orders.asc(Hql.property("name"))); 

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<ItemSubtype> query = Base.getConfiguredQuery(dc, cc, true, ItemSubtype.getQuery(null), mode);
		subtypes = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title==null ? "Item subtypes" : title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'subtypes';
		function newItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true);
		}
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', itemId);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 750, 500);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		</script>
	</base:head>
	
	<base:body>
		<h1><%=title==null ? "Item subtypes" : title%></h1>
		<div class="content">
		<tbl:table 
			id="subtypes" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="systemId"
				clazz="uniquecol"
				property="systemId"
				datatype="string"
				title="System ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="itemType"
				property="itemType"
				datatype="int"
				title="Main item type"
				enumeration="<%=items%>"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="pushAnnotations"
				property="pushAnnotations"
				datatype="boolean"
				title="Push annotations to parent"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="relatedTypes"
				property="&relatedSubtypes(name)"
				datatype="string"
				title="Related item types"
				filterable="true"
				exportable="true"
			/>			
			<tbl:columndef
				id="dataFileTypes"
				title="File types"
				property="&dataFileTypes(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button
						visible="<%=!mode.isSelectionMode() %>"
						disabled="<%=createPermission ? false : true %>"
						image="new.png"
						onclick="newItem()"
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new item subtype" : "You do not have permission to create item subtypes"%>"
					/>
					<tbl:button
						disabled="<%=deletePermission ? false : true %>"
						image="delete.png"
						onclick="deleteItems()"
						title="Delete"
						tooltip="<%=deletePermission ? "Delete the selected items" : "You do not have permission to delete item subtypes" %>" 
					/>
					<tbl:button 
						disabled="<%=!writePermission%>" 
						image="restore.png" 
						onclick="restoreItems()" 
						title="Restore" 
						tooltip="<%=writePermission ? "Restore the selected (deleted) items" : "You do not have permission to edit item subtypes" %>" 
					/>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						image="import.png" 
						onclick="runPlugin('ImportItems')" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						image="export.png" 
						onclick="runPlugin('ExportItems')" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						image="runplugin.png" 
						onclick="runPlugin('RunListPlugin')" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=subtypes == null ? 0 : subtypes.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								onclick="Forms.checkUncheck(document.forms[formId])" 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (subtypes != null)
					{
						
						while (subtypes.hasNext())
						{
							ItemSubtype item = subtypes.next();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String deletePermanently = "deleteItemPermanently("+itemId+")";
							boolean usePermission = item.hasPermission(Permission.USE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon
										image="systemitem.png"
										tooltip="This item is a system item"
										visible="<%=item.isSystemItem()%>" 
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="systemId"><%=Values.getString(item.getSystemId())%></tbl:cell>
								<tbl:cell column="itemType"><%=item.getMainItemType()%></tbl:cell>
								<tbl:cell column="pushAnnotations"><%=item.getPushAnnotations() %></tbl:cell>
								<tbl:cell column="relatedTypes">
									<%
									relatedQuery.setEntityParameter("subtype", item);
									String separator = "";
									for (ItemSubtype related : relatedQuery.list(dc))
									{
										out.write(separator);
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, related, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(related.getName()));
										}
										out.write(" (" + related.getMainItemType() + ")");
										separator = ", ";
									}
									%>
								</tbl:cell>
								<tbl:cell column="dataFileTypes">
									<%
									fileTypesQuery.setParameter("subtype", itemId, Type.INT);
									String separator = "";
									for (DataFileType dft : fileTypesQuery.list(dc))
									{
										out.write(separator);
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, dft, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(dft.getName()));
										}
										separator = ", ";
									}
									%>
								</tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=subtypes == null || subtypes.getTotalCount() == 0 ? "No item subtypes were found" : "No item subtypes on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (subtypes != null) subtypes.close();
	if (dc != null) dc.close();
}
%>
