<%-- $Id: edit_unit.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.UNIT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int quantityId = Values.getInt(request.getParameter("quantity_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Quantity quantity = null;
	Unit unit = null;
	List<String> symbols = null;
	if (itemId == 0)
	{
		title = "Create unit";
		cc.removeObject("item");
		quantity = Quantity.getById(dc, quantityId);
	}
	else
	{
		unit = Unit.getById(dc, itemId);
		quantity = unit.getQuantity();
		cc.setObject("item", unit);
		title = "Edit unit -- " + HTML.encodeTags(unit.getName());
		Set<String> temp = unit.getSymbols();
		temp.remove(unit.getDisplaySymbol());
		symbols = new ArrayList<String>();
		symbols.add(unit.getDisplaySymbol());
		if (temp.size() > 0) symbols.addAll(temp);
	}
	if (unit != null) unit.checkPermission(Permission.WRITE);
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), unit);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="toolbar.css,tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "unit" tab
		function validateUnit()
		{
			var frm = document.forms['unit'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.symbols.value) == '')
			{
				alert('You must enter at least one symbol');
				frm.symbols.focus();
				return false;
			}
			else if (isNaN(parseFloat(frm.referenceFactor.value)))
			{
				alert("'" + frm.referenceFactor.value + "' is not a valid number");
				frm.referenceFactor.focus();
				return false;
			}
			else if (isNaN(parseFloat(frm.referenceOffset.value)))
			{
				alert("'" + frm.referenceOffset.value + "' is not a valid number");
				frm.referenceOffset.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['unit'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
	
		function init()
		{
			var frm = document.forms['unit'];
			<%
			if (unit == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}

		function symbolsOnChange()
		{
			var frm = document.forms['unit'];
			var symbols = Main.trimString(frm.symbols.value).split('\n');
			var span = document.getElementById('symbol');
			if (symbols[0])
			{
				span.innerHTML = symbols[0];
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="unit" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="quantity_id" value="<%=quantityId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=unit != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Unit" validate="validateUnit()" helpid="unit.edit">
			<table class="fullform input100">
			<tr>
				<th>Title</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(unit == null ? Values.getString(cc.getPropertyValue("name"), "New unit") : unit.getName())%>" 
					maxlength="<%=Unit.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Symbols</th>
				<td>
					<textarea <%=requiredClazz%> name="symbols" rows="4"
					onchange="symbolsOnChange()"
					><%=Values.getString(symbols, "\n", true)%></textarea>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Conversion formula</th>
				<td>
					1 <span id="symbol"><%=unit == null ? "<i>unit</i>" : HTML.encodeTags(unit.getDisplaySymbol())%></span>
					=
						<%=HTML.encodeTags(quantity.getReferenceUnit())%>
					× <input <%=requiredClazz%> type="text" name="referenceFactor"
							value="<%=unit == null ? 1.0 : unit.getReferenceFactor()%>"
							onkeypress="return Numbers.numberOnly(event)"
							onchange="updateTestResult()" maxlength="12" style="width: 10em;">
					+ <input <%=requiredClazz%> type="text" name="referenceOffset"
							value="<%=unit == null ? 0.0 : unit.getReferenceOffset()%>"
							onkeypress="return Numbers.numberOnly(event)"
							onchange="updateTestResult()" maxlength="12" style="width: 10em;">
				</td>
				<td></td>
			</tr>
			<%
			if (unit != null)
			{
				%>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help" style="margin: 0.5em;">
							Changing the conversion formula triggers a conversion of existing annotation values
							to the new settings. This may result in loss of precision due to rounding or 
							truncation.
						</div>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(unit == null ? cc.getPropertyValue("description") : unit.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'unit', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
