<%-- $Id: configure.jsp 5908 2011-12-13 13:48:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ClientDefaultSetting"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	final Client server = Client.getById(dc, sc.getClientId());
	final ClientDefaultSetting adminName = server.getDefaultSetting("server.admin.name");
	final ClientDefaultSetting adminEmail = server.getDefaultSetting("server.admin.email");
	final ClientDefaultSetting about = server.getDefaultSetting("server.about");
	final ClientDefaultSetting getAccount = server.getDefaultSetting("server.get.account");
	final ClientDefaultSetting forgottenPassword = server.getDefaultSetting("server.forgotten.password");
	final ClientDefaultSetting transferRate = server.getDefaultSetting("server.transferRate");
	final ClientDefaultSetting reportbuglink = server.getDefaultSetting("server.links.reportbug");
	final ClientDefaultSetting helplink = server.getDefaultSetting("server.links.help");
	final ClientDefaultSetting faqlink = server.getDefaultSetting("server.links.faq");

	final boolean writePermission = server.hasPermission(Permission.WRITE);
	final String clazz = writePermission ? "class=\"text\"" : "class=\"text disabled\" disabled readonly";
	%>
	<base:page type="popup" title="Server configuration">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
	<script language="JavaScript">
	function validateFileTransfer()
	{
		return true;
	}
	function validateAbout()
	{
		return true;
	}
	function validateGetAccount()
	{
		return true;
	}
	function validateForgottenPassword()
	{
		return true;
	}
	function validateLinks()
	{
		return true;
	}
	// Submit the form
	function saveSettings()
	{
		var frm = document.forms["server"];
		if (TabControl.validateActiveTab('settings'))
		{
			frm.submit();
		}
	}
	function setTransferRate(unlimitedChecked)
	{
		var frm = document.forms['server'];
		var transferRate = frm.transfer_rate;
		if (unlimitedChecked)
		{
			Main.addClass(transferRate, 'disabled');
			transferRate.disabled = true;
			transferRate.oldValue = transferRate.value;
			transferRate.value = 'unlimited';
		}
		else
		{
			Main.removeClass(transferRate, 'disabled');
			transferRate.disabled = false;
			transferRate.value = transferRate.oldValue ? transferRate.oldValue : '';
		}
	}

	</script>

	</base:head>
	<base:body >
		<h1>Server configuration <base:help tabcontrol="settings" /></h1>
		<form name="server" action="submit_server.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SaveSettings">
	
		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom">
		<t:tab id="filetransfer" title="File transfer" 
			validate="validateFileTransfer()" helpid="serverconfig.filetransfer">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th>Max transfer rate</th>
				<td>
					<%
					long bytes = Values.getLong(transferRate.getValue());
					String fBytes = "";
					String theClazz = "text";
					if (bytes > 0)
					{
						fBytes = Values.formatBytes(bytes);
					}
					else
					{
						fBytes = "unlimited";
						theClazz += " disabled";
					}
					%>
					<input class="<%=theClazz%><%=writePermission ? "\"" : " disabled\" disabled readonly"%> 
						type="text" name="transfer_rate" value="<%=fBytes%>" size="16" maxlength="16"> per second<br>
					
				</td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<input type="checkbox" value="1" name="unlimited" <%=bytes==0 ? " checked" : ""%>
						id="unlimited"
						onclick="setTransferRate(this.checked)" title="Unlimited transfer rate">
						<label for="unlimited">Unlimited</label>
				</td>
			</tr>
			</table>
			</div>


			<div class="padded">
					The transfer rate is specified in bytes per second.
					You can use the following units (case-insensitive):
					<ul>
					<li><b>GB</b> or <b>G</b> for gigabyte values (<code>1.5 GB</code>)
					<li><b>MB</b> or <b>M</b> for megabyte values (<code>10M</code>)
					<li><b>kB</b> or <b>k</b> for kilobyte values (<code>800k</code>)
					<li><b>bytes</b> or <b>B</b> for byte values (<code>50 bytes</code>)
					</ul>
			</div>


		</t:tab>
		<t:tab id="about" title="About" validate="validateAbout()" helpid="serverconfig.about">
			<table class="fullform input100">
			<tr>
				<th>Administrator name</th>
				<td>
					<input <%=clazz%> type="text" name="name" value="<%=HTML.encodeTags(adminName.getValue())%>" size="40" maxlength="<%=User.MAX_NAME_LENGTH%>"></td>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Administrator email</th>
				<td>
					<input <%=clazz%> type="text" name="email" value="<%=HTML.encodeTags(adminEmail.getValue())%>" size="40" maxlength="<%=User.MAX_EMAIL_LENGTH%>"></td>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>About</th>
				<td>
					<textarea <%=clazz%> rows="10" name="about"><%=HTML.encodeTags(about.getValue())%></textarea>
				</td>
				<td style="width: 20px;">
					<a href="javascript:Main.zoom('About', 'server', 'about', <%=!writePermission%>)" title="Edit in larger window"><base:icon image="zoom.png" /></a>
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="account" title="Get account" validate="validateGetAccount()" helpid="serverconfig.getaccount">
			<table class="fullform input100 smaller">
			<tr class="dynamic">
				<th>Message</th>
				<td>
					<textarea <%=clazz%> rows="16"name="account"><%=HTML.encodeTags(getAccount.getValue())%></textarea>
				</td>
				<td style="width: 20px;">
					<a href="javascript:Main.zoom('Get account - message', 'server', 'account', <%=!writePermission%>)" title="Edit in larger window"><base:icon image="zoom.png" /></a>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="password" title="Forgotten password" validate="validateForgottenPassword()" helpid="serverconfig.password">
			<table class="fullform input100 smaller">
			<tr class="dynamic">
				<th>Message</th>
				<td>
					<textarea <%=clazz%> rows="16" name="password"><%=HTML.encodeTags(forgottenPassword.getValue())%></textarea>
				</td>
				<td style="width: 20px;">
					<a href="javascript:Main.zoom('Forgotten password - message', 'server', 'password', <%=!writePermission%>)" title="Edit in larger window"><base:icon image="zoom.png" /></a>
				</td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="links" title="Links" validate="validateLinks()" helpid="serverconfig.links">
		    <table class="fullform input100 smaller">
		     <tr>
				<th>Help</th>
				<td>
					<input <%=clazz%> type="text" name="help" 
						value="<%=HTML.encodeTags(helplink.getValue())%>" 
						maxlength="<%=ClientDefaultSetting.MAX_VALUE_LENGTH%>"></td>
				</td>
			</tr>
			<tr>
				<th>FAQ</th>
				<td>
					<input <%=clazz%> type="text" name="faq" 
						value="<%=HTML.encodeTags(faqlink.getValue())%>" 
						maxlength="<%=ClientDefaultSetting.MAX_VALUE_LENGTH%>"></td>
				</td>
			</tr>
			<tr>
				<th>Report a bug</th>
				<td>
					<input <%=clazz%> type="text" name="reportbug" 
						value="<%=HTML.encodeTags(reportbuglink.getValue())%>"
						maxlength="<%=ClientDefaultSetting.MAX_VALUE_LENGTH%>"></td>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>		
		</t:tab>
		</t:tabcontrol>

		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings();" title="Ok" />
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

