<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOPLATETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioPlateType bioPlateType = null;
	BioWell.LockMode lockMode = BioWell.LockMode.UNLOCKED;
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	ItemQuery<ItemSubtype> subtypesQuery = null;
	
	if (itemId == 0)
	{
		title = "Create bioplate type";
		cc.removeObject("item");
		int lm = Values.getInt(cc.getPropertyValue("lockMode"));
		lockMode = BioWell.LockMode.fromValue(lm);
		subtypesQuery = Base.getSubtypesQuery(null);
		subtypesQuery.restrict(
				Restrictions.in(
					Hql.property("itemType"), 
					Expressions.integer(Item.SAMPLE.getValue()), Expressions.integer(Item.EXTRACT.getValue())
				));
	}
	else
	{
		bioPlateType = BioPlateType.getById(dc, itemId);
		bioPlateType.checkPermission(Permission.WRITE);
		lockMode = bioPlateType.getLockMode();
		cc.setObject("item", bioPlateType);
		title = "Edit bioplate type -- " + HTML.encodeTags(bioPlateType.getName());
		try
		{
			currentSubtype = bioPlateType.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		if (bioPlateType.getBioMaterialType() != null)
		{
			subtypesQuery = Base.getSubtypesQuery(bioPlateType.getBioMaterialType());
		}
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioPlateType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);

	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "BioPlateType" tab
		function validateBioPlateType()
		{
			var frm = document.forms['bioPlateType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['bioPlateType'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			var frm = document.forms['bioPlateType'];
			<%
			if (bioPlateType == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				bioMaterialTypeOnChange();
				<%
			}
			%>
		}
		
		var subtypeOptions = null;
		function bioMaterialTypeOnChange()
		{
			var frm = document.forms['bioPlateType'];
			if (subtypeOptions == null)
			{
				// Cache all options in the list
				subtypeOptions = new Array();
				for (var i = 1; i < frm.subtype_id.length; i++)
				{
					var opt = frm.subtype_id[i];
					subtypeOptions[subtypeOptions.length] = frm.subtype_id[i];
				}
			}
			
			var bmType = frm.bioMaterialType[frm.bioMaterialType.selectedIndex].value;
			
			frm.subtype_id.selectedIndex = 0;
			if (bmType == '')
			{
				frm.subtype_id.disabled = true;
			}
			else
			{
				frm.subtype_id.disabled = false;
				// Clean the list...
				frm.subtype_id.length = 1;
				// ...and re-populate from the cache
				for (var i = 0; i < subtypeOptions.length; i++)
				{
					if (subtypeOptions[i].attributes['bmtype'].value == bmType)
					{
						frm.subtype_id[frm.subtype_id.length] = subtypeOptions[i];
					}
				}
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioPlateType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=bioPlateType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Bioplate type" validate="validateBioPlateType()" helpid="bioplatetype.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(bioPlateType == null ? Values.getString(cc.getPropertyValue("name"), "New bioplate type") : bioPlateType.getName())%>" 
					maxlength="<%=BioPlateType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Biomaterial type</th>
				<%
				if (bioPlateType == null)
				{
					%>
						<td>
							<select name="bioMaterialType" class="required unchangeable" onchange="bioMaterialTypeOnChange()">
							<option value="">- any -
							<option value="<%=Item.SAMPLE.name()%>">Sample
							<option value="<%=Item.EXTRACT.name()%>">Extract
							</select>
						</td>
					<%
				}
				else
				{
					%>
					<td><%=bioPlateType.getBioMaterialType() == null ? "- any -" : bioPlateType.getBioMaterialType()%></td>
					<%
				}
				%>
				<td></td>
			</tr>
			<%
			if (subtypesQuery != null)
			{
				%>
				<tr>
					<th>Biomaterial subtype</th>
					<td>
						<select name="subtype_id"
							<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
							onchange="subtypeOnChange()"
							>
						<%
						if (!readCurrentSubtype)
						{
							%>
							<option value="-1">- denied -
							<%
						}
						else
						{
							%>
							<option value="0">-any-
							<%
							int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
							for (ItemSubtype subtype : subtypesQuery.list(dc))
							{
								int id = subtype.getId();
								if (id != currentSubtypeId && subtype.isRemoved()) continue;
								%>
								<option value="<%=id == currentSubtypeId && bioPlateType != null ? -id : id%>" 
									<%=id == currentSubtypeId ? "selected" : ""%>
									title="<%=HTML.encodeTags(subtype.getDescription()) %>"
									bmtype="<%=subtype.getMainItemType().name() %>"
									><%=HTML.encodeTags(subtype.getName())%>
								<%
							}
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Well lock mode</th>
				<td>
					<select name="lockMode" class="selectionlist">
					<%
					for (BioWell.LockMode lm : BioWell.LockMode.values())
					{
						String selected = lm == lockMode ? "selected" : "";
						%>
						<option value="<%=lm.name()%>" <%=selected%>><%=lm%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(bioPlateType == null ? cc.getPropertyValue("description") : bioPlateType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'bioPlateType', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (bioPlateType == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
