<%-- $Id: index.jsp 5996 2012-03-05 13:23:34Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioPlateEventParticipant"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.Tag"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.InvalidDataException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if ("PlaceOnPlate".equals(cmd))
	{
		dc = sc.newDbControl();
		Item bioMaterialType = Item.valueOf(request.getParameter("itemType"));
		String subContext = Values.getString(request.getParameter("subcontext"), "");
		ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.PLACE_ON_PLATE);
		final int maxRecent = Base.getMaxRecent(sc);

		sc.setUserClientSetting("place-on-plate.auto-select-unmapped-item", 
				Values.getBoolean(request.getParameter("autoSelectUnmappedItem")) ? "1" : "0");
		BioPlate plate = BioPlate.getById(dc, Values.getInt(request.getParameter("plate_id")));
		int rows = Values.getInt(request.getParameter("rows"));
		int columns = Values.getInt(request.getParameter("columns"));
		
		BioPlateEventType placeOnPlate = BioPlateEventType.getById(dc, BioPlateEventType.PLACE_ON_PLATE);
		BioPlateEvent event = BioPlateEvent.getNew(dc, placeOnPlate);
		BioPlateEventParticipant destination = event.addParticipant(plate, "destination", 1);
		
		event.setName(Values.getStringOrNull(request.getParameter("name")));
		event.setDescription(Values.getStringOrNull(request.getParameter("description")));
		Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
		event.setEventDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("event_date"))));
		int protocolId = Values.getInt(request.getParameter("protocol_id"));
		if (protocolId > 0) 
		{
			Protocol pt = Protocol.getById(dc, protocolId);
			event.setProtocol(pt);
			cc.setRecent(pt, maxRecent);
		}
		int hardwareId = Values.getInt(request.getParameter("hardware_id"));
		if (hardwareId > 0)
		{
			Hardware hw = Hardware.getById(dc, hardwareId);
			event.setHardware(hw);
			cc.setRecent(hw, maxRecent);
		}
		dc.saveItem(event);
		
		int numPlaced = 0;
		for (int row = 0; row < rows; ++row)
		{
			for (int column = 0; column < columns; ++column)
			{
				int bioMaterialId = Values.getInt(request.getParameter("well." + row + "." + column));
				if (bioMaterialId > 0)
				{
					MeasuredBioMaterial bioMaterial = (MeasuredBioMaterial)bioMaterialType.getById(dc, bioMaterialId);
					BioWell well = plate.getBioWell(row, column);
					bioMaterial.setBioWell(well);
					BioMaterialEvent bmEvent = bioMaterial.newEvent(destination);
					bmEvent.setComment("Well: " + well.getCoordinate());
					dc.saveItem(bmEvent);
					numPlaced++;
				}
			}
		}
		
		dc.commit();
		message = "Placed " + numPlaced + " items on plate " + plate.getName();
	}
	else if ("MoveBioMaterial".equals(cmd))
	{
		dc = sc.newDbControl();
		ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.MOVE);
		final int maxRecent = Base.getMaxRecent(sc);
		sc.setUserClientSetting("move-biomaterial.show-source-coordinates", 
				Values.getBoolean(request.getParameter("showSourceCoordinates")) ? "1" : "0");

		BioPlate sourcePlate = BioPlate.getById(dc, Values.getInt(request.getParameter("sourceplate_id")));
		BioPlate destPlate = BioPlate.getById(dc, Values.getInt(request.getParameter("destplate_id")));
		int rows = Values.getInt(request.getParameter("rows"));
		int columns = Values.getInt(request.getParameter("columns"));
		
		BioPlateEventType moveBioMaterial = BioPlateEventType.getById(dc, BioPlateEventType.MOVE);
		BioPlateEvent event = BioPlateEvent.getNew(dc, moveBioMaterial);
		BioPlateEventParticipant destination = event.addParticipant(destPlate, "destination", 1);
		BioPlateEventParticipant source = event.addParticipant(sourcePlate, "source", 1);
		
		event.setName(Values.getStringOrNull(request.getParameter("name")));
		event.setDescription(Values.getStringOrNull(request.getParameter("description")));
		Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
		event.setEventDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("event_date"))));
		int protocolId = Values.getInt(request.getParameter("protocol_id"));
		if (protocolId > 0) 
		{
			Protocol pt = Protocol.getById(dc, protocolId);
			event.setProtocol(pt);
			cc.setRecent(pt, maxRecent);
		}
		int hardwareId = Values.getInt(request.getParameter("hardware_id"));
		if (hardwareId > 0)
		{
			Hardware hw = Hardware.getById(dc, hardwareId);
			event.setHardware(hw);
			cc.setRecent(hw, maxRecent);
		}
		dc.saveItem(event);
		
		int numMoved = 0;
		for (int row = 0; row < rows; ++row)
		{
			for (int column = 0; column < columns; ++column)
			{
				int bioMaterialId = Values.getInt(request.getParameter("well." + row + "." + column));
				if (bioMaterialId > 0)
				{
					MeasuredBioMaterial bioMaterial = (MeasuredBioMaterial)BioMaterial.getById(dc, bioMaterialId);
					BioWell well = destPlate.getBioWell(row, column);
					bioMaterial.setBioWell(well);
					BioMaterialEvent bmEvent = bioMaterial.newEvent(destination);
					bmEvent.setComment("Well: " + well.getCoordinate());
					dc.saveItem(bmEvent);
					numMoved++;
				}
			}
		}
		
		dc.commit();
		message = "Moved " + numMoved + " items to plate " + destPlate.getName();
	}
	else if ("CreateChildPlate".equals(cmd))
	{
		dc = sc.newDbControl();
		ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.CREATE_BIOMATERIAL);
		final int maxRecent = Base.getMaxRecent(sc);
		sc.setUserClientSetting("create-child-plate.show-source-coordinates", 
				Values.getBoolean(request.getParameter("showSourceCoordinates")) ? "1" : "0");

		BioPlate sourcePlate = BioPlate.getById(dc, Values.getInt(request.getParameter("sourceplate_id")));
		Item sourceBioMaterialType = sourcePlate.getBioPlateType().getBioMaterialType();
		Item childBioMaterialType = Item.valueOf(request.getParameter("child_biomaterial_type"));
		boolean isBioAssayEvent = childBioMaterialType == Item.PHYSICALBIOASSAY;
		
		// The event object
		BioPlateEventType createBioMaterial = BioPlateEventType.getById(dc, 
				isBioAssayEvent ? BioPlateEventType.PHYSICAL_BIOASSAY :  BioPlateEventType.CREATE_BIOMATERIAL);
		BioPlateEvent event = BioPlateEvent.getNew(dc, createBioMaterial);
		event.setName(Values.getStringOrNull(request.getParameter("event_name")));
		event.setDescription(Values.getStringOrNull(request.getParameter("event_description")));
		BioPlateEventParticipant sourceParticipant = event.addParticipant(sourcePlate, "source", 1);
		Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
		event.setEventDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("event_date"))));
		int protocolId = Values.getInt(request.getParameter("protocol_id"));
		if (protocolId > 0) 
		{
			Protocol pt = Protocol.getById(dc, protocolId);
			event.setProtocol(pt);
			cc.setRecent(pt, sourceBioMaterialType.name(), maxRecent);
		}
		int hardwareId = Values.getInt(request.getParameter("hardware_id"));
		if (hardwareId > 0)
		{
			Hardware hw = Hardware.getById(dc, hardwareId);
			event.setHardware(hw);
			cc.setRecent(hw, sourceBioMaterialType.name(), maxRecent);
		}
		dc.saveItem(event);

		// Child plates & biomaterial
		Hardware freezer = null;
		if (!isBioAssayEvent)
		{
			int freezerId = Values.getInt(request.getParameter("freezer_id"));
			if (freezerId > 0)
			{
				freezer = Hardware.getById(dc, freezerId);
				cc.setRecent(freezer, "freezer", maxRecent);
			}
		}
		ItemSubtype subtype = null;
		int subtypeId = Values.getInt(request.getParameter("subtype_id"));
		if (subtypeId > 0) 
		{
			subtype = ItemSubtype.getById(dc, subtypeId);
			cc.setRecent(subtype, sourceBioMaterialType.name(), maxRecent);
		}
		Tag tag = null;
		int tagId = Values.getInt(request.getParameter("tag_id"));
		if (tagId > 0) 
		{
			tag = Tag.getById(dc, tagId);
		}
		int numChildPlates = Values.getInt(request.getParameter("number_of_plates"));
		int size = Values.getInt(request.getParameter("size"));
		PlateGeometry childGeometry = null;
		if (!isBioAssayEvent)
		{
			childGeometry = PlateGeometry.getById(dc, Values.getInt(request.getParameter("plategeometry_id")));
			cc.setRecent(childGeometry, sourceBioMaterialType.name(), maxRecent);
		}
		int rows = isBioAssayEvent ? 1 : childGeometry.getRows();
		int columns = isBioAssayEvent ? size : childGeometry.getColumns();
		int numCreated = 0;
		BioPlateType childPlateType = null;
		if (!isBioAssayEvent)
		{
			childPlateType = BioPlateType.getById(dc, Values.getInt(request.getParameter("bioplatetype_id")));
			cc.setRecent(childPlateType, sourceBioMaterialType.name(), maxRecent);
		}
		Float usedQuantity = Values.getFloat(request.getParameter("used_quantity"));
		Float originalQuantity = Values.getFloat(request.getParameter("original_quantity"));
		for (int plateNo = 0; plateNo < numChildPlates; ++plateNo)
		{
			PhysicalBioAssay pba = null;
			BioMaterialEvent pbaCreationEvent = null;
			BioPlate childPlate = null;
			BioPlateEventParticipant destParticipant = null;
			if (isBioAssayEvent)
			{
				pba = PhysicalBioAssay.getNew(dc, sourceParticipant);
				pba.setName(Values.getStringOrNull(request.getParameter("plate." + plateNo + ".name")));
				pba.setDescription(Values.getStringOrNull(request.getParameter("plate_description")));
				pba.setSize(size);
				pba.setItemSubtype(subtype);
				dc.saveItem(pba);
				pbaCreationEvent = pba.getCreationEvent();
				pbaCreationEvent.setEventDate(event.getEventDate());
			}
			else
			{
				childPlate = BioPlate.getNew(dc, childGeometry, childPlateType);
				childPlate.setName(Values.getStringOrNull(request.getParameter("plate." + plateNo + ".name")));
				childPlate.setDescription(Values.getStringOrNull(request.getParameter("plate_description")));
				childPlate.setEventDate(event.getEventDate());
				if (freezer != null) childPlate.setFreezer(freezer);
				childPlate.setBarcode(Values.getStringOrNull(request.getParameter("plate." + plateNo + ".barcode")));
				dc.saveItem(childPlate);
				destParticipant = event.addParticipant(childPlate, "destination", plateNo);
			}
			for (int row = 0; row < rows; ++row)
			{
				for (int column = 0; column < columns; ++column)
				{
					String prefix = "well." + +plateNo + "." + row + "." + column;
					int bioMaterialId = Values.getInt(request.getParameter(prefix));
					if (bioMaterialId > 0)
					{
						MeasuredBioMaterial parent = (MeasuredBioMaterial)sourceBioMaterialType.getById(dc, bioMaterialId);
						if (isBioAssayEvent)
						{
							BioMaterialEventSource evtSrc = pbaCreationEvent.addSource(parent);
							evtSrc.setUsedQuantity(usedQuantity);
							evtSrc.setPosition(column+1);
						}
						else
						{
							BioWell well = childPlate.getBioWell(row, column);
							MeasuredBioMaterial child = null;
							if (childBioMaterialType == Item.SAMPLE)
							{
								child = Sample.getNew(dc, destParticipant);
							}
							else if (childBioMaterialType == Item.EXTRACT)
							{
								Extract extract = Extract.getNew(dc, destParticipant);
								if (tag != null)
								{
									extract.setTag(tag);
								}
								else if (parent instanceof Extract)
								{
									extract.setTag(((Extract)parent).getTag());
								}
								child = extract;
							}
							else
							{
								throw new InvalidDataException("Can't create child biomaterial of type: " + childBioMaterialType);
							}
							child.setItemSubtype(subtype);
							child.setName(Values.getStringOrNull(request.getParameter(prefix + ".name")));
							child.setDescription(Values.getStringOrNull(request.getParameter("child_description")));
							child.setBioWell(well);
							child.setOriginalQuantity(originalQuantity);
							child.getCreationEvent().setSource(parent).setUsedQuantity(usedQuantity);
							dc.saveItem(child);
						}
						numCreated++;
					}
				}
			}
		}

		dc.commit();
		if (isBioAssayEvent)
		{
			message = "Used " + numCreated + " items on " + numChildPlates + " physical bioassay(s)";
		}
		else
		{
			message = "Created " + numCreated + " items on " + numChildPlates + " child plate(s)";
		}
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>