<%-- $Id: inherit.jsp 6033 2012-03-29 09:20:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to display and modify the attributes of
	the of a news item

	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.core.Subtypable"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Tree"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
private void loadParents(Set<AnnotationSet> parentAnnotations, Set<Annotatable> parentItems, Annotatable current, Annotatable root)
{
	Set<Annotatable> parents = null;
	if (current instanceof PhysicalBioAssay)
	{
		Extract extract = null;
		PhysicalBioAssay bioAssay = (PhysicalBioAssay)current;
		try
		{
			if (root instanceof RawBioAssay)
			{
				extract = ((RawBioAssay)root).getParentExtract();
			}
			else if (root instanceof DerivedBioAssay)
			{
				extract = ((DerivedBioAssay)root).getExtract();
			}
		}
		catch (PermissionDeniedException ex)
		{}
		parents = bioAssay.getAnnotatableParents(0, extract);
	}
	else
	{
		parents = current.getAnnotatableParents();
	}
	if (parents == null) return;
	for (Annotatable parent : parents)
	{
		if (parent != null && parentItems.add(parent))
		{
			if (parent.hasPermission(Permission.USE) && parent.isAnnotated())
			{
				parentAnnotations.add(parent.getAnnotationSet());
			}
			loadParents(parentAnnotations, parentItems, parent, root);
		}
	}
}

private String generateJoustTree(Set<AnnotationSet> parentAnnotations, Set<AnnotationSet> nonParents, Set<Annotation> inheritedAnnotations, Set<AnnotationSet> inheritedSets)
{
	StringBuilder sb = new StringBuilder();
	String itemIcon = "Annotatable";
	String annotationIcon = "Annotation";
	String parameterIcon = "Parameter";
	String nonParentIcon = "NonParent";
	
	for (AnnotationSet as : parentAnnotations)
	{
		Annotatable item = null;
		String itemType = as.getItemType().toString();
		try
		{
			item = as.getItem();
		}
		catch (PermissionDeniedException ex)
		{}
		if (item instanceof Subtypable)
		{
			try
			{
				ItemSubtype subtype = ((Subtypable)item).getItemSubtype();
				if (subtype != null) itemType = subtype.getName();
			}
			catch (PermissionDeniedException ex)
			{}
		}
		
		String icon = nonParents.contains(as) ? nonParentIcon : itemIcon;
		
		boolean setInherited = inheritedSets != null && inheritedSets.contains(as);

		String input = "<input type=\"checkbox\""+
			" name=\"AS"+as.getId()+"\""+
			(setInherited ? " checked" : "")+
			" onclick=\"itemOnToggle(event, "+as.getId()+")\""+
			">";
		String name = item == null ? "<i>- denied -</i>" : 
			HTML.javaScriptEncode(((Nameable)item).getName()) + " <span class=\"itemsubtype\">(" + itemType + ")</span>";
		sb.append("var item").append(as.getId());
		sb.append(" = JoustMenu.addMenuItem(-1"); 
		sb.append(",'").append(icon).append("'");
		sb.append(",'").append(input).append(name).append("'");
		sb.append(", 'itemOnClick(event, ").append(as.getId()).append(")'");
		sb.append(", '', 'AS").append(as.getId()).append("', true);\n");

		List<Annotation> annotations = as.getAnnotations().list(as.getDbControl());
		SessionControl sc = as.getSessionControl();
		for (Annotation a : annotations)
		{
			Formatter formatter = FormatterFactory.getAnnotationFormatter(sc, a, null);
			boolean inherited = inheritedAnnotations != null && inheritedAnnotations.contains(a);
			AnnotationType at = a.getAnnotationType();
			String annotationName = at.getName();
			boolean isParameter = at.isProtocolParameter();

			String values = Values.getString(a.getValues(null), ", ", true, formatter);
			name = HTML.javaScriptEncode(annotationName +
				" [" + Values.trimString(values, 20)+"]");
			input = "<input type=\"checkbox\""+
				" name=\"A"+a.getId()+"\""+
				(inherited || setInherited ? " checked" : "")+
				(setInherited ? " disabled" : "")+
				" onclick=\"annotationOnToggle(event, "+a.getId()+")\""+
				">";
			sb.append("JoustMenu.addChildItem(item" + as.getId());
			sb.append(",'").append(isParameter ? parameterIcon : annotationIcon).append("'");
			sb.append(",'").append(input).append(name).append("'");
			sb.append(", 'annotationOnClick(event, ").append(a.getId()).append(")'");
			sb.append(", '', 'A").append(a.getId()).append("');\n");
			sb.append("annotationValues['A").append(a.getId()).append("'] = ");
			sb.append("'").append(HTML.javaScriptEncode(values)).append("';\n");
		}
	}
	return sb.toString();
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final boolean standalone = Values.getBoolean(request.getParameter("standalone"));

final DbControl dc = sc.newDbControl();
ItemResultList<AnnotationType> annotationTypes = null;
try
{
	final Annotatable item = itemId == 0 ? null : (Annotatable)itemType.getById(dc, itemId);
	Set<AnnotationSet> parentAnnotations = new java.util.LinkedHashSet<AnnotationSet>();
	Set<Annotatable> parentItems = new HashSet<Annotatable>();
	Set<AnnotationSet> nonParents = new HashSet<AnnotationSet>();

	if (item != null)
	{
		// Get all annotated parents and their annotation sets
		loadParents(parentAnnotations, parentItems, item, item);
	}
	if (standalone)
	{
		sc.getCurrentContext(itemType).setObject("item", item);	
	}
	String title = "Inherit annotations to " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
		(item == null ? " new item" : item.toString())));

	// Parent items may have been submitted by caller
	String[] parents = request.getParameterValues("parents");
	// Each parameter is ITEMTYPE:ID:ID:...
	if (parents != null)
	{
		for (String parent : parents)
		{
			String[] temp = parent.split(":");
			Item parentType = Item.valueOf(temp[0]);
			for (int i = 1; i < temp.length; ++i)
			{
				int parentId = Values.getInt(temp[i], -1);
				if (parentId != -1) 
				{
					Annotatable parentItem = (Annotatable)parentType.getById(dc, parentId);
					if (parentItems.add(parentItem))
					{
						// This is a new parent
						if (parentItem.hasPermission(Permission.USE) && parentItem.isAnnotated()) 
						{
							parentAnnotations.add(parentItem.getAnnotationSet());
						}
						loadParents(parentAnnotations, parentItems, parentItem, item);
					}
				}
			}
		}
	}
	
	// Get the currently inherited annotations
	final AnnotationSet as = item != null && item.isAnnotated() ? item.getAnnotationSet() : null;
	Set<Annotation> inheritedAnnotations = null;
	Set<AnnotationSet> inheritedSets = null;
	if (as != null)
	{
		ItemQuery<Annotation> inheritedQuery = as.getInheritedAnnotations();
		inheritedQuery.order(Orders.asc(Hql.property("annotationSet")));
		inheritedQuery.order(Orders.asc(Hql.property("annotationType.name")));
		inheritedAnnotations = new HashSet<Annotation>(inheritedQuery.list(dc));
		for (Annotation a : inheritedAnnotations)
		{
			AnnotationSet from = a.getAnnotationSet();
			if (!parentAnnotations.contains(from) && from.hasPermission(Permission.USE))
			{
				parentAnnotations.add(from);
				nonParents.add(from);
			}
		}
		
		ItemQuery<AnnotationSet> setQuery = as.getInheritedAnnotationSets();
		inheritedSets = new HashSet<AnnotationSet>(setQuery.list(dc));
		for (AnnotationSet ias : inheritedSets)
		{
			if (!parentAnnotations.contains(ias) && ias.hasPermission(Permission.USE))
			{
				parentAnnotations.add(ias);
				nonParents.add(ias);
			}
		}
	}
	%>
	<base:page type="popup" title="Inherit annotations">
	<base:head  scripts="annotations.js,parameters.js,newjoust.js,linkitems.js" styles="parameters.css,newjoust.css">
	<script language="JavaScript">
	var annotationValues = new Array();
	function init()
	{
		<%
		if (parentAnnotations.size() > 0)
		{
			%>
			IconStore.init();
			var path = getRoot() + 'images/joust/';
			IconStore.addIcon('Annotatable', path + 'annotatable.gif', 18, 16);
			IconStore.addIcon('Annotation', path + 'annotation.gif', 18, 16);
			IconStore.addIcon('Parameter', path + 'parameter.gif', 18, 16);
			IconStore.addIcon('NonParent', path + 'itemerror.gif', 18, 16);
			<%=generateJoustTree(parentAnnotations, nonParents, inheritedAnnotations, inheritedSets)%>
			JoustMenu.alwaysSendOnClickToSelected = true;
			JoustMenu.draw('joust');
			<%
		}
		%>
	}
	function itemOnClick(event, annotationSetId)
	{
		var frm = document.forms['annotations'];
		frm['AS'+annotationSetId].checked = !frm['AS'+annotationSetId].checked;
		itemOnToggle(event, annotationSetId);
	}
	
	function itemOnToggle(event, annotationSetId)
	{
		//alert('itemOnClick: '+annotationSetId);
		var frm = document.forms['annotations'];

		var linkedItem = Link.getItem('AS', annotationSetId);
		if (!linkedItem)
		{
			linkedItem = new Item('AS', annotationSetId);
		}
		var checked = frm['AS'+annotationSetId].checked;
		linkedItem.action += checked ? 1 : -1;

		frm['AS'+annotationSetId].checked = checked;
		var menuItem = JoustMenu.menuItems['AS'+annotationSetId];
		var childIndex = menuItem.firstChildIndex;
		while (childIndex != -1)
		{
			var childMenuItem = JoustMenu.menuItems[childIndex];
			frm[childMenuItem.externalId].checked = checked;
			frm[childMenuItem.externalId].disabled = checked;
			childIndex = childMenuItem.nextItemIndex;
			
			var annotationId = childMenuItem.externalId.substr(1);
			annotationItem = Link.getItem('A', annotationId);
			if (!annotationItem) annotationItem = new Item('A', annotationId);
			annotationItem.action = -1;
		}
		event.cancelBubble = true;
	}
	
	function annotationOnClick(event, annotationId)
	{
		var frm = document.forms['annotations'];
		var annotation = frm['A'+annotationId];
		if (!annotation.disabled)
		{
			annotation.checked = !annotation.checked;
			annotationOnToggle(event, annotationId);
		}
		document.getElementById('annotationValues').innerHTML = annotationValues['A'+annotationId];
	}
	
	function annotationOnToggle(event, annotationId)
	{
		//alert('itemOnClick: '+annotationSetId);
		var frm = document.forms['annotations'];

		var linkedItem = Link.getItem('A', annotationId);
		if (!linkedItem)
		{
			linkedItem = new Item('A', annotationId);
		}
		var checked = frm['A'+annotationId].checked;
		linkedItem.action = checked ? 1 : -1;
		
		frm['A'+annotationId].checked = checked;
		event.cancelBubble = true;
	}
	
	function saveAnnotations()
	{
		var frm = document.forms['modified'];
		Annotations.addInheritedAnnotationsToForm(window, frm);
		frm.submit();
	}

	</script>
	</base:head>
	<base:body onload="init()">
		<%
		if (standalone)
		{
			%>
			<h1><%=title%> <base:help helpid="annotations.inherit" /></h1>
			<div class="content bottomborder">
			<%
		}
		%>
	<form name="annotations">	
	<div class="absolutefull">
	
		<div class="absolutefull filled rightborder" style="width: 28em;">
		
			<div class="absolutefull parameterlist" style="bottom: 3em;">
				<div id="joust" class="joust">
					<%
					if (parentAnnotations.size() == 0) 
					{
						%>
						<div class="messagecontainer error">There are no parent items with annotations.</div>
						<%
					}
					%>
				</div>
			</div>
			
			<div class="absolutefull topborder" style="top: auto; bottom: 0px; height: 3em;">
				<table style="height: 100%; margin:auto;"><tr><td>
				<base:icon image="joust/annotation.gif" style="vertical-align: text-bottom;"/> = annotation
				<base:icon image="joust/parameter.gif" style="vertical-align: text-bottom;"/> = protocol parameter<br>
				<base:icon image="joust/itemerror.gif" style="vertical-align: text-bottom;" /> = not a parent item
				</td></tr></table>
			</div>
		
		</div>
		
		<div class="absolutefull" style="left: 28em; padding: 8px;" id="annotationValues">
		</div>
	
	</div>
	</form>

		<%
		if (standalone)
		{
			%>
			</div>
			<base:buttongroup subclass="dialogbuttons">
				<base:button onclick="saveAnnotations()" title="Save" />
				<base:button onclick="window.close()" title="Cancel" />
			</base:buttongroup>
			<form name="modified" method="post" action="index.jsp?ID=<%=ID%>">
				<input type="hidden" name="cmd" value="SaveAnnotations">
				<input type="hidden" name="item_type" value="<%=itemType.name()%>">
				<input type="hidden" name="item_id" value="<%=itemId%>">
			</form>
			<%
		}
		%>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

