<%-- $Id: finish_job.jsp 5910 2011-12-14 14:00:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PluginResponse"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.Response"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.util.EmailUtil"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job, false);
	PluginDefinition plugin = job.getPluginDefinition();
	PluginConfiguration pluginConfig = job.getPluginConfiguration();
	boolean sendMessage = Values.getBoolean(sc.getUserClientSetting("plugins.sendmessage"), true);
	boolean sendMessageAsEmail = EmailUtil.isEnabled(User.getById(dc, sc.getLoggedInUserId()));
	boolean removeJobWhenFinished = Values.getBoolean(sc.getUserClientSetting("plugins.removejob"), false);

	PluginResponse pluginResponse = (PluginResponse)sc.getSessionSetting("plugin.configure.response");
	boolean executeImmediately =
		pluginResponse != null && pluginResponse.getStatus() == Response.Status.EXECUTE_IMMEDIATELY;

	List<JobAgent> agents = null;
	if (!executeImmediately && sc.hasSystemPermission(Permission.SELECT_JOBAGENT))
	{
		ItemQuery<JobAgent> agentQuery = JobAgent.getQuery();
		agentQuery.join(Hql.innerJoin("plugins", "plg"));
		agentQuery.restrict(Restrictions.eq(Hql.index("plg", null), Hql.entity(plugin)));
		agentQuery.include(Include.ALL);
		agentQuery.order(Orders.asc(Hql.property("name")));
		agents = agentQuery.list(dc);
	}
	%>
	<base:page type="popup" title="Set job name and options">
	<base:head scripts="plugin.js">
		<script language="JavaScript">
		function doFinish()
		{
			var frm = document.forms['plugin'];
			if (Main.trimString(frm.name.value) == '')
			{
				frm.name.focus();
				alert('You must enter a name for the job');
				return false;
			}
			frm.submit();
		}
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		</script>
	</base:head>
	<base:body>
		<h1>Set job name and options <base:help helpid="runplugin.finishjob" /></h1>
		<form name="plugin" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="FinishNewJob">

		<div class="content">
			<table class="fullform input100 bottomborder">
			<tr>
				<th>Plugin</th>
				<td><%=HTML.encodeTags(plugin.getName())%></td>
				<td></td>
			</tr>
			<tr id="configurations">
				<th>Configuration</th>
				<td><%=pluginConfig == null ? "<i>- none -</i>" : HTML.encodeTags(pluginConfig.getName())%></td>
				<td></td>
			</tr>
			<tr>
				<th>Job name</th>
				<td><input type="text" class="text required" 
					name="name" value="<%=HTML.encodeTags(job.getName())%>" 
					maxlength="<%=Job.MAX_NAME_LENGTH%>">
				</td>
				<td></td>
			</tr>
			<%
			if (agents != null && agents.size() > 0)
			{
				%>
				<tr>
					<th>Use job agent</th>
					<td>
						<select name="agent_id">
						<option value="">- automatic -
						<%
						for (JobAgent agent : agents)
						{
							%>
							<option value="<%=agent.getId()%>"><%=HTML.encodeTags(agent.getName())%>
							<%
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Send message</th>
				<td>
					<input type="checkbox" name="send_message" id="sendMessage" value="1" <%=sendMessage ? "checked" : "" %>>
					<label for="sendMessage">Send a 
					message<%=sendMessageAsEmail ? "+email" : "" %> when the job is completed</label>
				</td>
				<td></td>
			</tr>
			
			<tr>
				<th>Remove job</th>
				<%
				if (plugin.getMainType().equals(Plugin.MainType.EXPORT) || 
						plugin.getMainType().equals(Plugin.MainType.IMPORT))
				{
					%>
					<td>
						<input type="checkbox" name="remove_job" id="removeJob" value="1" <%=removeJobWhenFinished ? "checked" : "" %>>
						<label for="removeJob">Remove job when finished</label>
					</td>
					<%
				}
				else
				{
					%>
					<td><i>- n/a -</i></td>
					<%
				}
				%>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Job description</th>
				<td>
					<textarea class="text" rows="4" name="job_description" 
						><%=HTML.encodeTags(job.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Job description', 'plugin', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</div>
		</form>
			
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="doFinish();" title="Finish" image="gonext.png" />
			<td width="50%"><base:button onclick="doCancel();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

