<%-- $Id: select_color.jsp 5911 2011-12-15 08:17:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	A window for selecting a color interactively from a color chart.

	@param title The title of the input field on the parent form
	@param form The name of the form where the input field is located
	@param input The name of the input field containing the current color value
	@param callback A javascript function to call to set the new color in the
		opener's form (optional, if not specified the color is just saved back to
		the original form)

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	String title = request.getParameter("title");
	String form = request.getParameter("form");
	String input = request.getParameter("input");
	String callback = request.getParameter("callback");
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="colorchart.css">
	<script language="JavaScript">
	function init()
	{
		var color = getColor();
		var frm = document.forms['color'];
		if (color && color.length == 4)
		{
			frm.red.value = color[1];
			frm.green.value = color[2];
			frm.blue.value = color[3];
		}
	}
	
	function getColor()
	{
		var frm = window.opener.document.forms['<%=form%>'];
		var colorString = frm['<%=input%>'].value;
		var colors = colorString.match('([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})');
		return colors;
	}
	
	function validateColor(color)
	{
		return color.match('[0-9A-Fa-f]{2}');
	}
	
	function setColor()
	{
		var frm = document.forms['color'];
		if (!validateColor(frm.red.value))
		{
			alert('Invalid red color value');
			frm.red.focus();
			return;
		}
		else if (!validateColor(frm.green.value))
		{
			alert('Invalid green color value');
			frm.green.focus();
			return;
		}
		else if (!validateColor(frm.blue.value))
		{
			alert('Invalid blue color value');
			frm.blue.focus();
			return;
		}
		
		var theColor = frm.red.value + frm.green.value + frm.blue.value;
		<%
		if (callback == null)
		{
			%>
			var frm = window.opener.document.forms['<%=form%>'];
			frm['<%=input%>'].value = theColor;
			<%
		}
		else
		{
			%>
			window.opener.<%=callback%>('<%=form%>', '<%=input%>', theColor);
			<%
		}
		%>
		window.close();
	}
	
	function colorOnClick(r, g, b)
	{
		var frm = document.forms['color'];
		frm.red.value = r;
		frm.green.value = g;
		frm.blue.value = b;
	}
	</script>
	<style>
	
	.colorchart
	{
		background:  #000000;
		border: 1px solid #000000;
		width: 100%; 
		height: 100%;
	}
	
	.colorchart td
	{
		border: 1px solid #000000;
		padding: 1px;
	}

	.colorchart td:hover
	{
		cursor: pointer;
		outline: 1px solid #FFFFFF;
		border: 2px solid #000000;
		padding: 0px;
	}
	</style>
</base:head>
<base:body onload="init()">
	<h1><%=title%><base:help helpid="colorchart.selectcolor" /></h1>
	<form name="color">
	<div class="content filled">
		<div class="absolutefull" style="bottom: 2em;">
		<table class="colorchart">
		<%
		int cells = 0;
		int red = 0;
		int green = 0;
		int blue = 0;
		while (red < 16 && green < 16 && blue < 16)
		{
			String r = Integer.toHexString(red).toUpperCase();
			String g = Integer.toHexString(green).toUpperCase();
			String b = Integer.toHexString(blue).toUpperCase();
			if (cells == 0)
			{
				%>
				<tr>
				<%
			}
			%>
			<td style="background: #<%=r+g+b%>;" title="#<%=r+r+g+g+b+b%>"
				onclick="colorOnClick('<%=r+r%>', '<%=g+g%>', '<%=b+b%>')"
				><div></div></td>
			<%
			cells++;
			if (cells == 18)
			{
				cells = 0;
				%>
				</tr>
				<%
			}
			red += 3;
			if (red == 18)
			{
				red = 0;
				green += 3;
				if (green == 9)
				{
					green = 0;
					blue += 3;
					if (blue == 18)
					{
						blue = 0;
						green = 9;
					}
				}
				else if (green == 18)
				{
					green = 9;
					blue += 3;
				}
			}
		}
		%>
		</table>
		</div>
		
		<div class="absolutefull" style="top: auto; bottom: 0px; height: 2em; border-top: 0px solid #000000;">
		<table style="margin: auto; height: 100%; border-spacing: 2px;" >
		<tr>
			<th>Red</th>
			<td><input class="text" type="text" name="red" value="" size="2" maxlength="2" title="Red color value in hexadecimal"></td>

			<th>Green</th>
			<td><input class="text" type="text" name="green" value="" size="2" maxlength="2" title="Green color value in hexadecimal"></td>

			<th>Blue</th>
			<td><input class="text" type="text" name="blue" value="" size="2" maxlength="2" title="Blue color value in hexadecimal"></td>
		</tr>
		</table>
		</div>

	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="setColor()" title="Ok" />
		<base:button onclick="window.close()" title="Cancel" />
	</base:buttongroup>
	
</base:body>
</base:page>
