<%-- $Id: zoom.jsp 5945 2012-02-02 13:49:44Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Open a larger window for editing text in a textarea.

	@param title The title of the input field that is zoomed
	@param form The name of the form where the zoomed input field is located
	@param textarea The name of the textarea that is zoomed

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
	String title = request.getParameter("title");
	String form = request.getParameter("form");
	String textarea = request.getParameter("textarea");
	boolean disabled = Values.getBoolean(request.getParameter("disabled"));
	String callback = request.getParameter("callback");
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="menu.js" styles="toolbar.css,menu.css,help.css">
	<script language="JavaScript">
	function init()
	{
		getText();
	}
	function getText()
	{
		var frm = document.forms["zoom"];
		frm.zoom.value = window.opener.document.forms['<%=form%>'].elements['<%=textarea%>'].value;
		frm.zoom.focus();
	}
	function setTextAndClose()
	{
		var value = document.forms["zoom"].zoom.value;
		var element = window.opener.document.forms['<%=form%>'].elements['<%=textarea%>'];
		element.value = value;
		element.focus();
		<%
		if (callback != null)
		{
			%>
			window.opener.<%=callback%>(value);
			<%
		}
		%>
		window.close();
	}
	
	/*
		Enclose the selected text with prefix and suffix. Code taken
		from Trac: http://projects.edgewall.com/trac/
	*/
	function encloseSelection(prefix, suffix)
	{
		var frm = document.forms['zoom'];
		var textarea = frm.zoom;
		textarea.focus();
	    var start, end, sel, scrollPos, subst;
	    if (typeof(document["selection"]) != "undefined") 
	    {
	      sel = document.selection.createRange().text;
	    } 
	    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
	    {
	      start = textarea.selectionStart;
	      end = textarea.selectionEnd;
	      scrollPos = textarea.scrollTop;
	      sel = textarea.value.substring(start, end);
	    }
	    if (sel.match(/ $/)) 
	    { 
	    	// exclude ending space char, if any
	      	sel = sel.substring(0, sel.length - 1);
	      	suffix = suffix + " ";
	    }
	    subst = prefix + sel + suffix;
	    if (typeof(document["selection"]) != "undefined") 
	    {
	      var range = document.selection.createRange().text = subst;
	      textarea.caretPos -= suffix.length;
	    } 
	    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
	    {
	      textarea.value = textarea.value.substring(0, start) + subst +
	                       textarea.value.substring(end);
	      if (sel) 
	      {
	        textarea.setSelectionRange(start + subst.length, start + subst.length);
	      } 
	      else 
	      {
	        textarea.setSelectionRange(start + prefix.length, start + prefix.length);
	      }
	      textarea.scrollTop = scrollPos;
	    }
	}
	</script>
</base:head>
<base:body onload="init()" attributes="onresize='setTimer();'">
	<h1><%=title%> <base:help helpid="zoom.edit" /></h1>
	<form name="zoom" onsubmit="return false;">

<div class="content">
	<m:menu
		id="listtype"
		style="display: none;">			
	<m:menuitem 
		title="Ordered list" 
		onclick="encloseSelection('&lt;ol&gt;', '&lt;/ol&gt;')"
		tooltip="Insert an ordered list"
	/>
	<m:menuitem
		title="Unordered list"
		onclick="encloseSelection('&lt;ul&gt;', '&lt;/ul&gt;')"
		tooltip="Insert an unordered list"
	/>			
	<m:menuitem
		title="List item"
		onclick="encloseSelection('&lt;li&gt;', '&lt;/li&gt;')"
		tooltip="Insert a listitem."
	/>			
	</m:menu>
	<%
	String tableInsert = "encloseSelection('&lt;table frame=&quot;borders&quot;&gt;', '&lt;/table&gt;')";
	%>
	<m:menu
		id="tableitem"
		style="display: none;">
	<m:menuitem
		title="Table"
		onclick="<%=tableInsert%>"
		tooltip="Insert a table"
	/>
	<m:menuitem
		title="Row"
		onclick="encloseSelection('&lt;tr&gt;', '&lt;/tr&gt;')"
		tooltip="Insert a tablerow."
	/>
	<m:menuitem
		title="Cell"
		onclick="encloseSelection('&lt;td&gt;', '&lt;/td&gt;')"
		tooltip="Insert a datacell."
	/>
	</m:menu>
	<m:menu
		id="textformats"
		style="display: none;">
	<m:menuitem
		title="Important"
		onclick="encloseSelection('&lt;imp&gt;', '&lt/imp&gt;')"
		tooltip="Mark text as important"
	/>
	<m:menuitem
		title="User input"
		onclick="encloseSelection('&lt;ui&gt;', '&lt/ui&gt;')"
		tooltip="Mark text as user input."
	/>
	<m:menuitem
		title="Required"
		onclick="encloseSelection('&lt;req&gt;', '&lt/req&gt;')"
		tooltip="Mark text as required user input."
	/>
	<m:menuitem
		title="Button text"
		onclick="encloseSelection('&lt;btn&gt;', '&lt/btn&gt;')"
		tooltip="Mark text to symbol a button."
	/>
	<m:menuitem
		title="Menu text"
		onclick="encloseSelection('&lt;mnu&gt;', '&lt/mnu&gt;')"
		tooltip="Mark text to symbol a menu."
	/>
	</m:menu>		
	<m:menu
		id="link"
		style="display: none;"
	>
	<m:menuitem
		title="Insert helptext"
		onclick="encloseSelection('{@include ', '}')"
		tooltip="Insert another helptext in this text."
	/>		
	<m:menuitem
		title="External link"
		onclick="encloseSelection('{@link ', '}')"
		tooltip="Insert an external link."
	/>
	<%
	String insertBookmarkLink = "encloseSelection('&lt;a href=&quot;#&quot&gt;', '&lt/a&gt;')";
	%>
	<m:menuitem
		title="Internal link"
		onclick="<%=insertBookmarkLink%>"
		tooltip="Insert a link to a part in this text."
	/>
	<%
	String insertBookmark = "encloseSelection('&lt;a&nbsp;name=&quot;&quot;&gt;', '&lt;/a&gt;')";
	%>
	<m:menuitem
		title="Bookmark"
		onclick="<%=insertBookmark%>"
		tooltip="Insert a bookmark"
	/>
	</m:menu>
			<%
			if (form.equals("help"))
			{
			%>
				<tbl:toolbar>												
					<tbl:button 
						tooltip="Bold"
						image="text_bold.png"
						onclick="encloseSelection('&lt;b&gt;', '&lt;/b&gt;')"
					/>
					<tbl:button
						tooltip="Italic"							
						image="text_italic.png"
						onclick="encloseSelection('&lt;i&gt;', '&lt;/i&gt;')"
					/>
					<tbl:button
						tooltip="Underline"
						image="text_underline.png"
						onclick="encloseSelection('&lt;u&gt;', '&lt;/u&gt;')"
					/>											
					<tbl:button
						tooltip="Header 3"
						image="text_h3.png"
						onclick="encloseSelection('&lt;h3&gt;', '&lt;/h3&gt;')"
					/>
					<tbl:button
						tooltip="Header 4"
						image="text_h4.png"
						onclick="encloseSelection('&lt;h4&gt;', '&lt;/h4&gt;')"
					/>
					<tbl:button
						tooltip="Textstyle"
						image="text_style_edit.png"
						onclick="Menu.toggleTopMenu(document.getElementById('textformats'), event.clientX, event.clientY); event.cancelBubble = true;"
					/>						
					<tbl:button
						tooltip="Table"
						image="text_table.png"
						onclick="Menu.toggleTopMenu(document.getElementById('tableitem'), event.clientX, event.clientY); event.cancelBubble = true;"
					/>
					<tbl:button
						tooltip="List"
						image="text_list.gif"
						onclick="Menu.toggleTopMenu(document.getElementById('listtype'), event.clientX, event.clientY); event.cancelBubble = true;"
					/>
					<tbl:button
						tooltip="New line"
						image="text_newline.gif" 
						onclick="encloseSelection('&lt;br&gt;', '')"
					/>
					<tbl:button
						tooltip="New paragraph"
						image="text_paragraph.gif"
						onclick="encloseSelection('&lt;p&gt;', '&lt;/p&gt;')"
					/>	
					<tbl:button
						tooltip="New link"
						image="text_link.png"
						onclick="Menu.toggleTopMenu(document.getElementById('link'), event.clientX, event.clientY); event.cancelBubble = true;"
					/>							
				</tbl:toolbar>
				<%
			}
			%>
			<table class="fullcc input100"><tr><td>
			<textarea class="autohight" id="zoom" name="zoom" rows="30"
				<%=disabled ? "disabled" : ""%>></textarea>
			</td></tr></table>
		</div>
		</form>
	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="window.close()" title="Close" visible="<%=disabled%>"/>
		<base:button onclick="setTextAndClose()" title="Ok" visible="<%=!disabled%>" />
		<base:button onclick="window.close()" title="Cancel" visible="<%=!disabled%>" />
	</base:buttongroup>
</base:body>
</base:page>
