<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.uri.ConnectionManagerUtil"
	import="net.sf.basedb.util.uri.ConnectionManagerFactory"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.FILESERVER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	FileServer server = null;

	if (itemId == 0)
	{
		title = "Create file server";
		cc.removeObject("item");
	}
	else
	{
		server = FileServer.getById(dc, itemId);
		server.checkPermission(Permission.WRITE);
		cc.setObject("item", server);
		title = "Edit file server -- " + HTML.encodeTags(server.getName());
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), server);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	List<ConnectionManagerFactory> cmFactories = ConnectionManagerUtil.getFactories();
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "File server" tab
		function validateFileServer()
		{
			var frm = document.forms['server'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		
		function validateCertificates()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['server'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (server == null)
			{
				%>
				var frm = document.forms['server'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			connectionManagerOnChange();
		}
		
		var currentCMF;
		function connectionManagerOnChange()
		{
			var frm = document.forms['server'];
			if (currentCMF) Main.hide(currentCMF);
			
			var cmfId = frm.connectionManager[frm.connectionManager.selectedIndex].value;
			if (!cmfId) cmfId = 'auto';
			currentCMF = 'cmf.' + cmfId + '.description';
			Main.show(currentCMF);
		}

		
		function removeServerCertificateOnClick()
		{
			var frm = document.forms['server'];
			if (frm.remove_server_certificate.checked)
			{
				frm.server_certificate.value = '';
				frm.server_certificate.disabled = true;
			}
			else
			{
				frm.server_certificate.disabled = false;
			}
		}
		function removeClientCertificateOnClick()
		{
			var frm = document.forms['server'];
			if (frm.remove_client_certificate.checked)
			{
				frm.client_certificate.value = '';
				frm.client_certificate.disabled = true;
				frm.client_certificate_password.disabled = true;
			}
			else
			{
				frm.client_certificate.disabled = false;
				frm.client_certificate_password.disabled = false;
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings"/></h1>
		
		<form action="index.jsp?ID=<%=ID%>&cmd=UpdateItem" method="post" name="server" enctype="multipart/form-data" onsubmit="return false;">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=server != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="File server" validate="validateFileServer()" helpid="fileserver.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("name"), "New file server") : server.getName())%>" 
					maxlength="<%=FileServer.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Connection manager</th>
				<td>
					<select name="connectionManager" onchange="connectionManagerOnChange()">
					<option value="">- auto -
					<%
					String currentFactoryId = server == null ? cc.getPropertyValue("connectionManagerFactory") : server.getConnectionManagerFactoryId();
					for (ConnectionManagerFactory cmf : cmFactories)
					{
						String cmfId = cmf.getId();
						String selected = cmfId.equals(currentFactoryId) ? "selected" : "";
						%>
						<option value="<%=cmf.getId()%>" <%=selected%>><%=HTML.encodeTags(cmf.getDisplayName())%><%=cmf.useAutoDetection() ? " (•)" : "" %>
						<%
					}
					%>
					</select>
					
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<div class="messagecontainer help" style="margin: 0.5em 0px 0.5em 0px; height: <%=(int)(scale*70)%>px; overflow: auto;">
					<div id="cmf.auto.description" style="display: none;">
						Automatically select a connection manager among those 
						that supports auto-detection.
					</div>
					<%
					for (ConnectionManagerFactory cmf : cmFactories)
					{
						String cmfId = cmf.getId();
						%>
						<div id="cmf.<%=cmfId%>.description" style="display: none;">
							<%=HTML.encodeTags(cmf.getDescription())%>
						</div>
						<%
					}
					%>
					</div>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Host</th>
				<td><input <%=clazz%> type="text" name="host" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("host")) : server.getHost())%>" 
					maxlength="<%=FileServer.MAX_HOST_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Username</th>
				<td><input <%=clazz%> type="text" name="username" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("username")) : server.getUsername())%>" 
					maxlength="<%=FileServer.MAX_USERNAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Password</th>
				<td><input <%=clazz%> type="password" name="password" 
					value="" maxlength="<%=FileServer.MAX_PASSWORD_LENGTH%>" placeholder="leave empty to keep the password"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" cols="40" name="description" 
						><%=HTML.encodeTags(server == null ? cc.getPropertyValue("description") : server.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'server', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="serverCertificate" title="Certificates" validate="validateCertificates()" 
			helpid="fileserver.edit">
			
			<table class="fullform input100">
			<tr class="big">
				<th>Server certificate</th>
				<td>
					<input <%=clazz%> type="file" name="server_certificate" size="40"><br>
					<input type="checkbox" name="remove_server_certificate" id="removeServerCertificate" value="1" 
						onclick="removeServerCertificateOnClick()"><label for="removeServerCertificate">Remove existing server certificate</label><br><br>
				</td>
			</tr>
			<tr>
				<th>Client certificate</th>
				<td>
					<input <%=clazz%> type="file" name="client_certificate" size="40">
				</td>
			</tr>
			<tr>
				<th class="subprompt">Password</th>
				<td>
					<input <%=clazz%> type="password" name="client_certificate_password">
				</td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<input type="checkbox" name="remove_client_certificate" id="removeClientCertificate" value="1" 
						onclick="removeClientCertificateOnClick()"><label for="removeClientCertificate">Remove existing client certificate</label>
				</td>
			</tr>
			
			<tr class="dynamic">
				<th></th>
				<td>
						<div class="helpmessage">
							A <b>server certificate</b> may be needed to access files with https on servers that
							use self-signed certificates. You may select a file containing the server's X.509 certificate
							in either binary or base64-encoded DER format. 
							<p>
							A <b>client certificate</b> may be needed to access files with https on servers
							that require client authentication using certificates. You should select a file
							containing your key in PKCS #12 format. If the file is password-protected you must
							enter the password as well.
						</div>
				</td>
			</tr>
			</table>
			
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			• = supports auto-detection<br>
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />>
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
