<%-- $Id: manage_plates.jsp 6006 2012-03-13 08:53:24Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.ArrayDesignPlate"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ARRAYDESIGN;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	ArrayDesign design = ArrayDesign.getById(dc, itemId);
	cc.setObject("item", design);
	String title = "Attach plate -- " + HTML.encodeTags(design.getName());
	if (!design.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Plates" tab
		function validatePlates()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['design'];
			if (validatePlates())
			{
				var plates = frm.plates;
				for (var i = 0; i < plates.length; ++i) // >
				{
					plates[i].selected = true;
				}
				frm.submit();
			}
		}
		
		function addPlatesOnClick()
		{
			var ids = Link.getListIds(document.forms['design'].plates, '');
			var excludes = ids.join(',');
			var url = '../plates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addPlateCallback';
			url += '&excludes='+excludes;
			Main.openPopup(url, 'AddPlates', 1050, 700);
		}

		function addPlateCallback(plateId, name)
		{
			var item = Link.getItem('', plateId);
			if (!item) item = new Item('', plateId, name);
			Link.addItem(document.forms['design'].plates, item);
		}
		
		function removePlatesOnClick()
		{
			Link.removeSelected(document.forms['design'].plates);
		}

		function init()
		{
			var frm = document.forms['design'];
			var plates = frm.plates;
			<%
			ItemQuery<ArrayDesignPlate> platesQuery = design.getArrayDesignPlates();
			platesQuery.include(Include.MINE, Include.SHARED, Include.OTHERS, Include.IN_PROJECT);
			platesQuery.order(Orders.asc(Hql.property("position")));
			ItemResultList<ArrayDesignPlate> plates = platesQuery.list(dc);
			for (ArrayDesignPlate adPlate : plates)
			{
				Plate plate = adPlate.getPlate();
				%>
				Link.addNewItem(plates, new Item('', <%=plate.getId()%>, '<%=HTML.javaScriptEncode(plate.getName())%>'));
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help helpid="arraydesign.edit.plates" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="design" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdatePlates">

		<div class="content bottomborder">
			<table class="fullform">
			<tr>
				<th>Array design</th>
				<td><%=HTML.encodeTags(design.getName())%></td>
			</tr>
			<tr class="dynamic">
				<th>Plates</th>
				<td>
					<div class="selectionlist">
					<table>
					<tr style="vertical-align: top;">
					<td>
						<base:buttongroup vertical="true">
							<base:button
								onclick="Forms.moveListOptions(document.forms['design'].plates, false)"
								image="move_up.png" 
								tooltip="Move up" 
								subclass="square"
							/>
							<base:button 
								onclick="Forms.moveListOptions(document.forms['design'].plates, true)" 
								image="move_down.png" 
								tooltip="Move down" 
								subclass="square"
							/>
						</base:buttongroup>
					</td>
					<td>
						<select name="plates" size="15" multiple>
						</select>
					</td>
					<td>
						<base:buttongroup vertical="true">
							<base:button 
								subclass="leftaligned"
								style="width: 12em;"
								onclick="addPlatesOnClick()" 
								title="Add plates..." 
								tooltip="Add plates to be used"
							/>
							<base:button 
								subclass="leftaligned"
								style="width: 12em;"
								onclick="removePlatesOnClick()" 
								title="Remove" 
								tooltip="Remove the selected plates"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			</table>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
