<%-- $Id: main.jsp 5977 2012-02-20 13:26:26Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This is the front page of BASE. It displays a login form
	and some of the relevant news items.

	@param login The value to display in the login input field.
	@param error An error message that should be displayed

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.servlet.RssNewsFeed"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String error = Values.getString(request.getParameter("error"), null);
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
final DbControl dc = sc.newDbControl();
String broadcastTitle = (String)application.getAttribute("broadcast.title");
String broadcastMessage = (String)application.getAttribute("broadcast.message");
boolean denyLogin = Boolean.TRUE.equals(application.getAttribute("broadcast.deny-login"));
ItemResultList<News> news = null;
try
{
	%>
	<base:page type="default" title="">
	<base:head styles="login.css">
		<script language="JavaScript" type="text/javascript">
		// Set foucs on the login form
		function init()
		{
			setFocus();
		}
		
		// Set the focus on either the login or password field.
		function setFocus()
		{
			frm = document.forms['login'];
			if (frm.login.value == '' && window.parent.lastLogin) frm.login.value = window.parent.lastLogin;
			if (frm.login.value == '')
			{
				frm.login.focus();
				frm.login.select();
			}
			else
			{
				frm.password.focus();
				frm.password.select();
			}
		}
		function saveLogin()
		{
			var frm = document.forms['login'];
			window.parent.lastLogin = frm.login.value;
			return true;
		}
		function doLogin()
		{
			var frm = document.forms['login'];
			if (frm.login.disabled) return;
			var denyLogin = <%=denyLogin ? "true" : "false"%>;
			if (denyLogin && !confirm('Login has been disabled by an administrator. Do you want to continue anyway?'))
			{
				return false;
			}
			saveLogin();
			frm.submit();
		}
		function enableLogin()
		{
			var frm = document.forms['login'];
			Main.hide('loginAnyway');
			frm.login.disabled = false;
			frm.password.disabled = false;
			frm.login.focus();
			Main.removeClass(document.getElementById('loginBtn'), 'disabled');
		}
		</script>
	</base:head>
	
	<base:body onload="init();" style="padding-top: 5em;">
		<form name="login" action="login.jsp" method="post" onsubmit="doLogin();">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="nextpage" value="<%=root%>my_base/user/index.jsp">
		
		<table style="margin: auto; width: 600px;">
		<tr>
		<td>
			<table style="width: 100%;">
			<tr>
				<td style="background-color: #000000; border-radius: 4px 0px 0px 4px;"><img src="images/baselogo.png" alt="BASE logo"></td>
				<td>
					<div id="loginform">
					<table>
						<tr>
							<th>Login</th>
							<td><input class="text" type="text" name="login" value="<%=HTML.encodeTags(login)%>" 
								maxlength="100"	style="width: 12em;" <%=denyLogin ? "disabled" : ""%>
								tabindex="0"
								>
							</td>
							<td></td>
						</tr>
						<tr>
							<th>Password</th>
							<td>
								<input class="text" type="password" name="password" maxlength="80"
									onkeypress="return Forms.submitOnEnter(event, doLogin)"
									style="width: 12em;" <%=denyLogin ? "disabled" : ""%>
									tabindex="0"
									>
							</td>
							<td><base:button 
								id="loginBtn"
								subclass="<%=denyLogin ? "disabled" : ""%>"
								image="login.png" title="Login" 
								onclick="doLogin();" tooltip="<%=HTML.encodeTags(broadcastTitle)%>" /></td>
						</tr>
						<tr>
							<th></th>
							<td colspan="2">
							<%
							String forgotPassword = sc.getClientDefaultSetting("server.forgotten.password");
							String getAccount = sc.getClientDefaultSetting("server.get.account");
							if (forgotPassword != null)
							{
								%>
								<base:icon image="bullet.png" />
								<a href="javascript:Main.openPopup('info/forgot_password.jsp?ID=<%=ID%>', 'ForgotPassword', 450, 300)" title="Click here if you have forgotten your password">Forgot your password?</a>
								<%
							}
							if (getAccount != null)
							{
								%>
								<base:icon image="bullet.png" />
								<a href="javascript:Main.openPopup('info/get_account.jsp?ID=<%=ID%>', 'GetAccount', 450, 300)" title="Click here if you want to get an account on this server">Get an account!</a>
								<%
							}
							%>
							</td>
						</tr>
						</table>
					</div>
				
				
				</td>
			</tr>
			</table>
		
			
			<%
			if (error != null) 
			{
				%>
				<div class="messagecontainer error"><%=error%></div>
				<%
			}
			%>
			<%
			if (denyLogin)
			{
				%>
				<div id="denyLogin">
					<div class="messagecontainer help"">
					<b><%=HTML.encodeTags(broadcastTitle) %> (login disabled)</b><br>
					<%=HTML.niceFormat(broadcastMessage)%>
					</div>
					<base:buttongroup id="loginAnyway">
						<base:button title="Login anyway" onclick="enableLogin()" image="login.png" tooltip="At your own risk!" />
					</base:buttongroup>
				</div>
				<%
			}
			%>
			
			<%
			String aboutServer = sc.getClientDefaultSetting("server.about");
			if (aboutServer != null)
			{
				%>
				<h3 style="margin-top: 1em;">About this server</h3>
				<p>
					<%=aboutServer%>
				</p>
				<base:icon image="bullet.png" />
				<a href="javascript:Main.openPopup('info/about.jsp?ID=<%=ID%>&page=about', 'About', 600, 400)">More about this server</a>
				<%
			}
			%>
			
			<h3 style="margin-top: 1em;">News and announcements 
			<%
			if (RssNewsFeed.isEnabled()) 
			{
				%>
				<a href="info/news.rss" 
					title="Subscribe to news from this BASE server"
					><base:icon image="rss.png" style="float: right; margin-top: 1px;"/></a>
				<%
			}
			%>
			</h3>
			<div id="news" class="news">
			<%
			if (broadcastTitle != null)
			{
				%>
				<div class="item">
					<div class="headline">
						<base:icon image="warning.png" />
						<span class="date"><%=dateFormatter.format(new Date())%></span>
						<%=HTML.encodeTags(broadcastTitle)%><%=denyLogin ? " (login disabled)" : "" %>
					</div>
					<div class="text"><%=HTML.niceFormat(broadcastMessage)%></div>
				</div>
				<% 
			}
			
			ItemQuery<News> query = News.getQuery();
			query.order(Orders.desc(Hql.property("newsDate")));
			query.order(Orders.desc(Hql.property("id")));
			query.setCacheResult(true);
			query.setReturnTotalCount(true);
			query.setMaxResults(10);
			news = query.list(dc);
			for (News n : news)
			{
				%>
				<div class="item">
					<div class="headline">
						<span class="date"><%=dateFormatter.format(n.getNewsDate())%></span>
						<%=HTML.encodeTags(n.getName())%>
					</div>
					<div class="text"><%=HTML.niceFormat(n.getDescription())%></div>
				</div>
				<%
			}
			if (news.getTotalCount() > 10)
			{
				%>
				<base:icon image="bullet.png" /><a href="info/news.jsp" 
					title="Show older news..."><%=news.getTotalCount()-10%> more</a>
				<%
			}
			%>
			</div>
		</td>
		</tr>
		</table>

		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

