<%-- $Id: switch.jsp 6001 2012-03-12 12:13:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	%>
	<base:page type="popup" title="Switch user">
	<base:head styles="login.css">
		<script language="JavaScript" type="text/javascript">
		// Set foucs on the login form
		function init()
		{
			setFocus();
		}
		
		// Set the focus on either the login or password field.
		function setFocus()
		{
			frm = document.forms['login'];
			if (frm.login.value == '' && window.parent.lastLogin) frm.login.value = window.parent.lastLogin;
			if (frm.login.value == '')
			{
				frm.login.focus();
			}
			else
			{
				frm.password.focus();
				frm.password.select();
			}
		}
		function saveLogin()
		{
			var frm = document.forms['login'];
			window.opener.parent.lastLogin = frm.login.value;
			return true;
		}
		function doLogin()
		{
			saveLogin();
			var frm = document.forms['login'];
			if (frm.remainOnPage.checked) 
			{
				frm.redirect.value = '';
			}
			else
			{
				frm.redirect.value = '<%=root%>my_base/index.jsp?ID=<%=ID%>';
			}
			frm.submit();
		}
		</script>
	</base:head>
	
	<base:body onload="init();">
		<h1>Switch user <base:help helpid="switchuser" /></h1>
		<form name="login" action="login.jsp" method="post" onsubmit="doLogin();">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="again" value="1">
		<input type="hidden" name="redirect" value="">
	
		<div class="content">
			<table class="fullform input100 bottomborder ">
			<tr>
				<th>Login</th>
				<td><input  type="text" name="login" value="<%=HTML.encodeTags(login)%>" 
					 maxlength="100"></td>
			</tr>
			<tr>
				<th>Password</th>
				<td>
					<input type="password" name="password" maxlength="80"
						onkeypress="return Forms.submitOnEnter(event, saveLogin)">
				</td>
			</tr>
			<tr>
				<th><label for="remainOnPage">Remain on this page</label></th>
				<td>
					<input type="checkbox" name="remainOnPage" id="remainOnPage" checked value="1">
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button image="login.png" onclick="doLogin();" title="Login" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
		

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

