<%-- $Id: save_as.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
%>
<base:page type="popup" title="Save as">
<base:head>
	<script language="JavaScript">
	// Initialise - set focus to filename field
	function init()
	{
		var frm = document.forms['saveas'];
		frm.path.value = window.opener.lastPath ? window.opener.lastPath : '';
		frm.path.focus();
	}

	// Validate the form
	function validateForm()
	{
		var frm = document.forms['saveas'];
		if (Main.trimString(frm.path.value) == '')
		{
			frm.path.focus();
			alert('Please enter a filename');
			return false;
		}
		return true;
	}
	
	function browseOnClick()
	{
		Main.openPopup(getRoot()+'filemanager/save_as.jsp?ID=<%=ID%>&callback=setFileCallback', 'SaveAs', 1050, 700);
	}
	function setFileCallback(path)
	{
		var frm = document.forms['saveas'];
		frm.path.value = path;
	}

	// Submit the form
	function saveAs()
	{
		var frm = document.forms['saveas'];
		if (validateForm())
		{
			var url = window.opener.generatePlotUrl(true);
			if (url)
			{
				window.opener.lastPath = frm.path.value;
				url += '&saveAs=' + frm.path.value;
				url += '&overwrite=' + (frm.overwrite.checked ? 1 : 0);
				Main.hide('save');
				Main.hide('buttons');
				Main.show('generating');
				location.href = url;
			}
		}
	}
	</script>
</base:head>
<base:body onload="init()">
	<h1>Save plot</h1>
	
	<form name="saveas" onsubmit="return false;">
	<div class="content bottomborder" id="save">
		<table class="fullform input100 smaller">
		<tr>
			<th>Save as</th>
			<td>
				<table style="width: 100%;">
				<tr>
					<td><input type="text" class="text" name="path" value=""></td>
					<td style="width: 10em;"><base:button 
						title="Browse&hellip;"
						onclick="browseOnClick()"
						/></td>
				</tr>
				</table>
			</td>
		</tr>
		<tr>
			<th class="subprompt"></th>
			<td>
				<input type="checkbox" name="overwrite" id="overwrite" value="1"><label for="overwrite">Overwrite existing file</label><br>
			</td>
		</tr>
		<tr class="dynamic">
			<th></th>
			<td></td>
		</table>
	</div>
	</form>

	<base:buttongroup subclass="dialogbuttons" id="buttons">
		<base:button onclick="saveAs();" title="Ok" />
		<base:button onclick="window.close();" title="Cancel" />
	</base:buttongroup>
	
	<div class="content" id="generating" style="display: none">
		<table class="fullcc"><tr><td>
		<b>Generating plot. Please wait...</b>
		</td></tr></table>
	</div>
	
</base:body>
</base:page>
